/**********************************************************************************************/
/* OpenSi : Logiciel SaaS de gestion commerciale et comptabilit spcialis dans l'e-commerce */
/* Copyright (c) - Tous droits rservs - SAS Speedinfo Evolution                             */
/**********************************************************************************************/


jsLoader.loadSubScript("chrome://opensi/content/libs/query.js");


function init() {
  try {

  	window.resizeTo(900,500);

		var qDate = new QueryHttp("GetDates.tmpl");
		document.getElementById('labelAvancement').value = "Etat d'avancement au "+ qDate.execute().responseXML.documentElement.getAttribute("auj");
		chargerAvancement();

		document.getElementById('bQuitter').focus();

  } catch (e) {
    recup_erreur(e);
  }
}


function chargerAvancement() {
  try {

		var XUL_NS = "http://www.mozilla.org/keymaster/gatekeeper/there.is.only.xul";
		var rgp = "N";

		var qAvancement = new QueryHttp("Compta/Etats/Avancement.tmpl");
		qAvancement.setParam("Exercice", rgp);
		var result = qAvancement.execute();
		var listeJournaux = result.responseXML.documentElement.getAttribute("Liste_Journaux").split(",");
		var listeNbOp = result.responseXML.documentElement.getAttribute("Liste_Nb_Op").split(",");
		var listePeriodes = result.responseXML.documentElement.getAttribute("Liste_Periodes").split(",");
		var listeNbOpPeriodes = result.responseXML.documentElement.getAttribute("Liste_Nb_Op_Periodes").split(",");
		var listeTotauxPeriodes = result.responseXML.documentElement.getAttribute("Liste_Totaux_Periodes").split(",");
		var totalGeneral = result.responseXML.documentElement.getAttribute("Total_General");

		var gridAvancement = document.getElementById('gridAvancement');
		while (gridAvancement.hasChildNodes()) { gridAvancement.removeChild(gridAvancement.firstChild); }

	  var columns = document.createElementNS(XUL_NS, "xul:columns");
	  var column = document.createElementNS(XUL_NS, "xul:column");
	  column.setAttribute("style", "min-width:50px");
	  columns.appendChild(column);
	  for (var i=0; i<listeJournaux.length-1; i++) {
	  	column = document.createElementNS(XUL_NS, "xul:column");
	  	column.setAttribute("style", "min-width:50px");
	  	columns.appendChild(column);
	  }
	  column = document.createElementNS(XUL_NS, "xul:column");
  	column.setAttribute("style", "min-width:50px");
	  columns.appendChild(column);
	  gridAvancement.appendChild(columns);
	  var rows = document.createElementNS(XUL_NS, "xul:rows");
	  var row = document.createElementNS(XUL_NS, "xul:row");
	  var label = document.createElementNS(XUL_NS, "xul:label");
	  label.setAttribute("class", "case_entete");
	  label.setAttribute("value", "");
	  row.appendChild(label);
	  for (var i=0; i<listeJournaux.length-1; i++) {
		  var codeJournal = listeJournaux[i];
		  label = document.createElementNS(XUL_NS, "xul:label");
		  label.setAttribute("class", "row_entete");
		  label.setAttribute("value", codeJournal);
		  label.setAttribute("style", "text-align:center;font-weight:bold");
		  row.appendChild(label);
	  }
	  label = document.createElementNS(XUL_NS, "xul:label");
	  label.setAttribute("class", "row_entete");
	  label.setAttribute("value", "Total");
	  label.setAttribute("style", "text-align:center;font-weight:bold");
	  row.appendChild(label);
	  rows.appendChild(row);

	  var rang = 0;
	  for (var i=0; i<listePeriodes.length-1; i++) {
	  	row = document.createElementNS(XUL_NS, "xul:row");
		  var periode = listePeriodes[i];
		  var totalPeriode = listeTotauxPeriodes[i];
		  label = document.createElementNS(XUL_NS, "xul:label");
		  label.setAttribute("class", "col_entete");
		  label.setAttribute("value", periode);
		  label.setAttribute("style", "text-align:center;font-weight:bold");
		  row.appendChild(label);
		  for (var j=0; j<listeJournaux.length-1; j++) {
		  	var codeJournal = listeJournaux[j];
		  	var nbOp = listeNbOpPeriodes[rang];
		  	rang++;
		  	label = document.createElementNS(XUL_NS, "xul:label");
			  label.setAttribute("class", "case");
			  label.setAttribute("value", nbOp);
			  label.setAttribute("style", "text-align:right");
				if (rgp=="N") {
					label.setAttribute("ondblclick", "gms_ouvrirSaisie('"+ codeJournal +"', '"+ periode.replace('/', '') +"')");
				}
			  row.appendChild(label);
		  }
		  label = document.createElementNS(XUL_NS, "xul:label");
		  label.setAttribute("class", "case");
		  label.setAttribute("value", totalPeriode);
		  label.setAttribute("style", "text-align:right");
		  row.appendChild(label);
		  rows.appendChild(row);
	  }

	  row = document.createElementNS(XUL_NS, "xul:row");
	  row.setAttribute("style", "border-bottom: solid 1px");
	  label = document.createElementNS(XUL_NS, "xul:label");
	  label.setAttribute("class", "case_entete");
	  label.setAttribute("value", "Total");
	  label.setAttribute("style", "text-align:center;font-weight:bold");
	  row.appendChild(label);
	  for (var i=0; i<listeNbOp.length-1; i++) {
		  var codeJournal = listeJournaux[i];
		  var nbOp = listeNbOp[i];
		  label = document.createElementNS(XUL_NS, "xul:label");
		  label.setAttribute("class", "row_case");
		  label.setAttribute("value", nbOp);
		  label.setAttribute("style", "text-align:right");
		  row.appendChild(label);
	  }
	  label = document.createElementNS(XUL_NS, "xul:label");
	  label.setAttribute("class", "row_case");
	  label.setAttribute("value", totalGeneral);
	  label.setAttribute("style", "text-align:right");
	  row.appendChild(label);
	  rows.appendChild(row);
	  gridAvancement.appendChild(rows);

	} catch (e) {
    recup_erreur(e);
  }
}
