/**********************************************************************************************/
/* OpenSi : Logiciel SaaS de gestion commerciale et comptabilit spcialis dans l'e-commerce */
/* Copyright (c) - Tous droits rservs - SAS Speedinfo Evolution                             */
/**********************************************************************************************/

jsLoader.loadSubScript("chrome://opensi/content/libs/formatter.js");
jsLoader.loadSubScript("chrome://opensi/content/libs/verif.js");
jsLoader.loadSubScript("chrome://opensi/content/libs/query.js");

var ctrlComptes = 0;
var ctrlJournaux = 0;
var ctrlTiers = 0;
var ctrlCJ = 0;

var nfs = new NumberFormat("0.00", true);



function init() {
  try {

		document.getElementById('progression').setAttribute("mode", "undetermined");

		document.getElementById("Sous_Titre").value = "calcul en cours des \u00E0 nouveaux temporaires...";

		var qANTemp = new QueryHttp('Compta/UpdateDatabase/RegenererANouveaux.tmpl');
		qANTemp.execute(init0);

	} catch (e) {
    recup_erreur(e);
  }
}


function init0(result) {
  try {

		document.getElementById('progression').setAttribute("mode", "determined");
		document.getElementById('progression').value = 10;

		var qCrtlNbOp = new QueryHttp('Compta/ControlCoherence/CtrlNbOp.tmpl');
		qCrtlNbOp.execute(init1);

	} catch (e) {
    recup_erreur(e);
  }
}

function init1(result) {
  try {

		document.getElementById('progression').value = 20;
		document.getElementById("Sous_Titre").value = "NOMBRE TOTAL D'ECRITURES DANS L'EXERCICE : "+ result.responseXML.documentElement.getAttribute('nb');

		var qCtrlComptes = new QueryHttp('Compta/ControlCoherence/CtrlComptes.tmpl');
		qCtrlComptes.execute(init2);

	} catch (e) {
    recup_erreur(e);
  }
}


function init2(result) {
  try {

		var creditCptes = 0;
		var debitCptes = 0;

		var contenu = result.responseXML.documentElement;

		var credit = 0;
		var debit = 0;
		var ecart = 0;

		for (i=1;i<contenu.childNodes.length;i++) {

			if (contenu.childNodes.item(i).nodeType==Node.ELEMENT_NODE) {

				credit += parseFloat(contenu.childNodes.item(i).getAttribute('credit'));
				debit += parseFloat(contenu.childNodes.item(i).getAttribute('debit'));
				ecart = debit - credit;

				document.getElementById("Credit_Compte").value = nfs.format(credit);
				document.getElementById("Debit_Compte").value = nfs.format(debit);
				document.getElementById("Ecart_Compte").value = nfs.format(ecart);
			}
		}
		creditCptes = credit;
		debitCptes = debit;
		if (ecart<0.01 && ecart>-0.01) {
			ctrlComptes = 1;
			document.getElementById("Ecart_Compte").value = "0.00";
		}
		document.getElementById('progression').value = 45;

		var qCtrl = new QueryHttp("Compta/ControlCoherence/CtrlJournaux.tmpl");
		qCtrl.execute(init3, new Array(creditCptes,debitCptes));

	} catch (e) {
    recup_erreur(e);
  }
}

function init3(result, params) {
  try {

    var creditCptes = params[0];
    var debitCptes = params[1];
		var creditJ = 0;
		var debitJ = 0;

		var contenu = result.responseXML.documentElement;

		var credit = 0;
		var debit = 0;
		var ecart = 0;

		for (i=1;i<contenu.childNodes.length;i++) {

			if (contenu.childNodes.item(i).nodeType==Node.ELEMENT_NODE) {

				credit += parseFloat(contenu.childNodes.item(i).getAttribute('credit'));
				debit += parseFloat(contenu.childNodes.item(i).getAttribute('debit'));
				ecart = debit - credit;

				document.getElementById("Credit_Journal").value = nfs.format(credit);
				document.getElementById("Debit_Journal").value = nfs.format(debit);
				document.getElementById("Ecart_Journal").value = nfs.format(ecart);
			}
		}
		document.getElementById('progression').value = 55;

		creditJ = credit;
		debitJ = debit;

		if (ecart<0.01 && ecart>-0.01) {
			ctrlJournaux = 1;
			document.getElementById("Ecart_Journal").value = "0.00";
		}

		var ecartCreditCJ = creditCptes - creditJ;
		var ecartDebitCJ = debitCptes - debitJ;

		if (ecartCreditCJ<0.01 && ecartCreditCJ>-0.01 && ecartDebitCJ<0.01 && ecartDebitCJ>-0.01) {
			ctrlCJ = 1;
		}

		var qCtrl = new QueryHttp("Compta/ControlCoherence/CtrlFournisseur.tmpl");
		qCtrl.execute(init4);

	} catch (e) {
    recup_erreur(e);
  }
}


function init4(result) {
  try {

		var creditF = 0;
		var debitF = 0;

		var contenu = result.responseXML.documentElement;

		for (i=1;i<contenu.childNodes.length;i++) {

			if (contenu.childNodes.item(i).nodeType==Node.ELEMENT_NODE) {

				creditF += parseFloat(contenu.childNodes.item(i).getAttribute('credit'));
				debitF += parseFloat(contenu.childNodes.item(i).getAttribute('debit'));

				document.getElementById("Credit_Fournisseur").value = nfs.format(creditF);
				document.getElementById("Debit_Fournisseur").value = nfs.format(debitF);
			}
		}

		var qCtrl = new QueryHttp("Compta/ControlCoherence/CtrlCollectif.tmpl");
		qCtrl.setParam("Racine", "40");
		qCtrl.execute(init5, new Array(creditF,debitF));

		document.getElementById('progression').value = 75;

	} catch (e) {
    recup_erreur(e);
  }
}


function init5(result, params) {
  try {

    var creditF = params[0];
    var debitF = params[1];
		var credit40;
		var debit40;

		var contenu = result.responseXML.documentElement;

		credit40 = contenu.getAttribute('credit');
		debit40 = contenu.getAttribute('debit');

		document.getElementById("Credit_40").value = nfs.format(credit40);
		document.getElementById("Debit_40").value = nfs.format(debit40);

		var ecartCF40 = creditF-credit40;
		var ecartDF40 = debitF-debit40;

		document.getElementById("Ecart_CF").value = nfs.format(ecartCF40);
		document.getElementById("Ecart_DF").value = nfs.format(ecartDF40);

		if (ecartCF40<0.01 && ecartCF40>-0.01) {
			document.getElementById("Ecart_CF").value = "0.00";
		}

		if (ecartDF40<0.01 && ecartDF40>-0.01) {
			document.getElementById("Ecart_DF").value = "0.00";
		}

		var qCtrl = new QueryHttp("Compta/ControlCoherence/CtrlClient.tmpl");
		qCtrl.execute(init6, new Array(creditF,debitF,credit40,debit40));

		document.getElementById('progression').value = 80;

	} catch (e) {
    recup_erreur(e);
  }
}


function init6(result, params) {
  try {

    var creditF = params[0];
    var debitF = params[1];
    var credit40 = params[2];
    var debit40 = params[3];
		var debitC = 0;
		var creditC = 0;

		var contenu = result.responseXML.documentElement;

		for (i=1;i<contenu.childNodes.length;i++) {

			if (contenu.childNodes.item(i).nodeType==Node.ELEMENT_NODE) {

				creditC += parseFloat(contenu.childNodes.item(i).getAttribute('credit'));
				debitC += parseFloat(contenu.childNodes.item(i).getAttribute('debit'));

				document.getElementById("Credit_Client").value = nfs.format(creditC);
				document.getElementById("Debit_Client").value = nfs.format(debitC);
			}
		}

		var qCtrl = new QueryHttp("Compta/ControlCoherence/CtrlCollectif.tmpl");
		qCtrl.setParam("Racine", "41");
		qCtrl.execute(init7, new Array(creditF,debitF,credit40,debit40,creditC,debitC));

		document.getElementById('progression').value = 95;

	} catch (e) {
    recup_erreur(e);
  }
}


function init7(result, params) {
  try {

    var creditF = params[0];
    var debitF = params[1];
    var credit40 = params[2];
    var debit40 = params[3];
    var creditC = params[4];
    var debitC = params[5];
		var credit41;
		var debit41;

		var contenu = result.responseXML.documentElement;

		credit41 = contenu.getAttribute('credit');
		debit41 = contenu.getAttribute('debit');

		document.getElementById("Credit_41").value = nfs.format(credit41);
		document.getElementById("Debit_41").value = nfs.format(debit41);

		var ecartCC41 = creditC-credit41;
		var ecartDC41 = debitC-debit41;

		document.getElementById("Ecart_DC").value = nfs.format(ecartDC41);
		document.getElementById("Ecart_CC").value = nfs.format(ecartCC41);

		if (ecartCC41<0.01 && ecartCC41>-0.01) {
			document.getElementById("Ecart_CC").value = "0.00";
		}

		if (ecartDC41<0.01 && ecartDC41>-0.01) {
			document.getElementById("Ecart_DC").value = "0.00";
		}

		document.getElementById('progression').value = 100;

		document.getElementById('bRapport').collapsed = false;

		var ecartTiers = parseFloat(debit41)-debitC+parseFloat(credit41)-creditC+parseFloat(debit40)-debitF+parseFloat(credit40)-creditF;

		if (ecartTiers<0.001 && ecartTiers>-0.001) {
			ctrlTiers = 1;
		}

		if ((ctrlTiers+ctrlComptes+ctrlJournaux+ctrlCJ)!=4) {
			document.getElementById('bContact').collapsed = false;
		}
		else {
			document.getElementById('bEntrer').collapsed = false;
		}

	} catch (e) {
    recup_erreur(e);
  }
}


function editerRapport() {
	try {

		var qEditionPdf = new QueryHttp("Compta/ControlCoherence/GenRapport.tmpl");
		qEditionPdf.setParam("CtrlCJ", ctrlCJ);
		qEditionPdf.setParam("CtrlComptes", ctrlComptes);
		qEditionPdf.setParam("CtrlJournaux", ctrlJournaux);
		qEditionPdf.setParam("CtrlTiers", ctrlTiers);
		qEditionPdf.execute(suiteEditerRapport);

	} catch (e) {
    recup_erreur(e);
  }
}


function suiteEditerRapport(result) {
	try {

  	window.location = "chrome://opensi/content/compta/user/affiche_pdf_rapport.xul?"+ cookie() +"&CtrlComptes="+ ctrlComptes +"&CtrlJournaux="+ ctrlJournaux +"&CtrlTiers="+ ctrlTiers;

	} catch (e) {
    recup_erreur(e);
  }
}


function envoyerRapport() {
	try {

		var qEditionPdf = new QueryHttp("Compta/ControlCoherence/GenRapport.tmpl");
		qEditionPdf.setParam("EnvoiMail", "y");
		qEditionPdf.setParam("CtrlCJ", ctrlCJ);
		qEditionPdf.setParam("CtrlComptes", ctrlComptes);
		qEditionPdf.setParam("CtrlJournaux", ctrlJournaux);
		qEditionPdf.setParam("CtrlTiers", ctrlTiers);
		qEditionPdf.execute(suiteEnvoyerRapport);

	} catch (e) {
    recup_erreur(e);
  }
}


function suiteEnvoyerRapport(result) {
  try {

		showMessage("Le rapport a \u00E9t\u00E9 envoy\u00E9");

	} catch (e) {
    recup_erreur(e);
  }
}


function entrer() {
  try {

		window.location = "chrome://opensi/content/compta/user/menu_exercice.xul?"+ cookie() +"&Dates="+ ParamValeur('Dates');

	} catch (e) {
    recup_erreur(e);
  }
}


function retour_exercice() {
  try {

    window.location = "chrome://opensi/content/compta/user/menu_dossier.xul?"+ cookie();

  } catch (e) {
    recup_erreur(e);
  }
}


function retourChoixDossier() {
  try {

    window.location = "chrome://opensi/content/compta/user/menu.xul?"+ cookie();

  } catch (e) {
    recup_erreur(e);
  }
}

