/**********************************************************************************************/
/* OpenSi : Logiciel SaaS de gestion commerciale et comptabilit spcialis dans l'e-commerce */
/* Copyright (c) - Tous droits rservs - SAS Speedinfo Evolution                             */
/**********************************************************************************************/

jsLoader.loadSubScript("chrome://opensi/content/libs/formatter.js");
jsLoader.loadSubScript("chrome://opensi/content/libs/arbres.js");
jsLoader.loadSubScript("chrome://opensi/content/libs/verif.js");
jsLoader.loadSubScript("chrome://opensi/content/libs/query.js");

var liste_options;
var currentChampCompte;
var aBalance;


function init() {
  try {

		document.getElementById('Type').value = "G";
		document.getElementById('Periode').selectedItem = document.getElementById('PeriodeEC');
		document.getElementById('Edition').selectedItem = document.getElementById('EditionC');
		document.getElementById('Ed_Cpte').selectedItem = document.getElementById('EdCpteT');
		document.getElementById('Sortie').selectedItem = document.getElementById('SortieP');

  } catch (e) {
    recup_erreur(e);
  }
}

function cacheChampsMail(b) {
	try {
		document.getElementById('ChampsMail').collapsed = b;

		if (b) {
			document.getElementById('BoutonEdition').label = "EDITER LA BALANCE";
		}
		else {
			document.getElementById('BoutonEdition').label = "ENVOYER LA BALANCE";
		}

	} catch (e) {
    recup_erreur(e);
  }
}

function disableDates(b) {
	try {

		document.getElementById('Date_Debut').disabled = b;
		document.getElementById('Date_Fin').disabled = b;

	} catch (e) {
    recup_erreur(e);
  }
}

function disableCptes(b) {
	try {

		document.getElementById('Cpte_Debut').disabled = b;
		document.getElementById('Cpte_Fin').disabled = b;
		document.getElementById('bCpte_Debut').disabled = b;
		document.getElementById('bCpte_Fin').disabled = b;

	} catch (e) {
    recup_erreur(e);
  }
}


function rechcompte(id) {
	try {

		var typeCompte = document.getElementById('Type').value;
		var numCompte = document.getElementById(id).value;

		var titre = "";

		if (typeCompte!="T") {
    	if (typeCompte=="C") {
    		titre ="CLIENT";
    	} else if (typeCompte=="F") {
    		titre ="FOURNISSEUR";
    	} else if (typeCompte=="A") {
    		titre ="AUXILIAIRE";
			} else if (typeCompte=="G") {
    		titre ="GENERAL";
    	}
    }

		currentChampCompte = id;
    var url = "chrome://opensi/content/compta/user/comptes/popup-rechercheCompte.xul";
    window.openDialog(url,'','chrome,modal,centerscreen', retourRechCompte, numCompte, typeCompte, titre, "", "");

	} catch (e) {
		recup_erreur(e);
	}
}


function retourRechCompte(numCompte, compteId) {
	try {

		document.getElementById(currentChampCompte).value = numCompte;

	} catch (e) {
		  recup_erreur(e);
	}
}


function keypress(e,id) {
  try {

    if (e.keyCode == 13){
      rechcompte(id);
    }

  } catch (e) {
    recup_erreur(e);
  }
}


function retour_menu_principal() {
  try {

    window.location = "chrome://opensi/content/compta/user/menu_exercice.xul?"+ cookie();

	} catch (e) {
    recup_erreur(e);
  }
}


function editerBalance() {
	try {

		var date_debut = document.getElementById('Date_Debut').value;
		var date_fin = document.getElementById('Date_Fin').value;
		var cpte_debut = document.getElementById('Cpte_Debut').value;
		var cpte_fin = document.getElementById('Cpte_Fin').value;

		if (document.getElementById('EditionP').selected && (!isCompteCorrect(cpte_debut) || !isCompteCorrect(cpte_fin))) {
			showMessage("Num\u00E9ros de compte invalides !");
		}
		else if (document.getElementById('PeriodeDD').selected && (!isDate(date_fin) || !isDate(date_debut) || !isDateInterval(date_debut, date_fin))) {
			showMessage("Plage de dates invalide !");
		}
		else {
			liste_options = "&Date_Debut="+ date_debut;
			liste_options += "&Date_Fin="+ date_fin;
			liste_options += "&Cpte_Debut="+ cpte_debut;
			liste_options += "&Cpte_Fin="+ cpte_fin;
			liste_options += "&Type="+ document.getElementById('Type').value;
			liste_options += "&Periode="+ document.getElementById('Periode').value;
			liste_options += "&Edition="+ document.getElementById('Edition').value;
			liste_options += "&Ed_Cpte="+ document.getElementById('Ed_Cpte').value;

			var sortie = document.getElementById('Sortie').value;

			if (sortie=="M") {

				var email = document.getElementById('Email').value;
				var sujet = document.getElementById('Sujet').value;
				var message = document.getElementById('Message').value;

				if (!isEmail(email)) {
					showMessage("Adresse e-mail incorrecte !");
				}
				else {
					var corps = cookie() + "&Page=Compta/Etats/balance_pdf.tmpl&ContentType=xml&EnvoiMail=y";
          corps += liste_options+"&Email="+urlEncode(email)+"&Sujet="+urlEncode(sujet)+"&Message="+urlEncode(message);
          requeteHTTP(corps,new XMLHttpRequest(),suiteEditer);
				}
			}	else if (sortie=="E") {
			document.getElementById('deck').selectedIndex = 2;
			document.getElementById('bRetourOptions').collapsed = false;
				var t = document.getElementById('Type').value;
				if (t=="T") t="G";

				loadBalance(t,'');

			} else if (sortie=="C") {
				var corps = cookie() + "&Page=Compta/Etats/balance_csv.tmpl&ContentType=xml" + liste_options;
        requeteHTTP(corps,new XMLHttpRequest(),suiteEditerCSV);
			}
			else {
				page = getUrlOpeneas("&Page=Compta/Etats/balance_pdf.tmpl" + liste_options);
				document.getElementById('balance_pdf').setAttribute("src", page);
				document.getElementById('deck').selectedIndex = 1;
				document.getElementById('bRetourOptions').collapsed = false;
			}
		}

	} catch (e) {
    recup_erreur(e);
  }
}
function retour_options() {
  try {

		document.getElementById('balance_pdf').setAttribute("src", "");
   	document.getElementById('deck').selectedIndex = 0;
		document.getElementById('bRetourOptions').collapsed = true;

  } catch (e) {
    recup_erreur(e);
  }
}
function suiteEditer(httpRequest) {
  try {

    showMessage("La balance a \u00E9t\u00E9 envoy\u00E9e !");

	} catch (e) {
    recup_erreur(e);
  }
}

function suiteEditerCSV(httpRequest) {
  try {

    var contenu = httpRequest.responseXML;

		var fichier_csv = contenu.documentElement.getAttribute('fichier');
		var nomFichier = formaterNomFichier("balance", "csv");
		var file = fileChooser("save", nomFichier);
		if (file!=null) {
			downloadFile(getDirBuffer()+ fichier_csv, file);

		}

	} catch (e) {
    recup_erreur(e);
  }
}

/****************************/
/*** deck 2 sortie ecran***/




var like = "";
var typeCompte = "";
var enableGoTo = false;
var nfs = new NumberFormat("0.00", true);


function disableBoutons(b) {
	try {

		document.getElementById('bMenuPrincipal').disabled = b;
		document.getElementById('bRetourOptions').disabled = b;
		document.getElementById('bA').disabled = b;
		document.getElementById('bG').disabled = b;
		document.getElementById('bC').disabled = b;
		document.getElementById('bF').disabled = b;
		document.getElementById('b1').disabled = b;
		document.getElementById('b2').disabled = b;
		document.getElementById('b3').disabled = b;
		document.getElementById('b4').disabled = b;
		document.getElementById('b5').disabled = b;
		document.getElementById('b6').disabled = b;
		document.getElementById('b7').disabled = b;

		enableGoTo = !b;

	} catch (e) {
    recup_erreur(e);
  }
}


function loadBalance(t,l) {
	try {

		disableBoutons(true);

		like = l;
		typeCompte = t;

		var titre = "";

		if (t=="F") {
			titre = "Fournisseurs";
		}
		else if (t=="C") {
			titre = "Clients";
		}
		else if (t=="A") {
			titre = "Auxiliaires";
		}
		else if (t=="G" && l=="") {
			titre = "G\u00E9n\u00E9raux";
		}
		else {
			titre = "de la classe "+ l;
		}

		document.getElementById('Titre').value = "Edition de la balance : Comptes "+ titre;

		document.getElementById('TotalDebit').value = '0.00';
		document.getElementById('TotalCredit').value = '0.00';
		document.getElementById('TotalSolde').value = '0.00';

		init_tree();

	} catch (e) {
    recup_erreur(e);
  }
}


function endLoading() {
	try {

		if (aBalance.nbLignes()<1) {
      endLoading2();
    }
		else {
			if (aBalance.getCellText(0,'ColDebit')=="") {
				setTimeout("endLoading()",50);
			}
			else {
				var debit = 0;
				var credit = 0;

				document.getElementById('Progression').collapsed = true;
				document.getElementById('pm').setAttribute('mode','none');

				for (i=0; i<aBalance.nbLignes(); i++) {
					debit += parseFloat(aBalance.getCellText(i,'ColDebit').replace(/ /i,''));
					credit += parseFloat(aBalance.getCellText(i,'ColCredit').replace(/ /i,''));
				}

				if (debit<0.01 && debit>-0.01) debit = 0;
				if (credit<0.01 && credit>-0.01) credit = 0;
				var solde = debit - credit;

				if (solde<0.01 && solde>-0.01) solde = 0;

				document.getElementById('TotalDebit').value = nfs.format(debit);
				document.getElementById('TotalCredit').value = nfs.format(credit);
				document.getElementById('TotalSolde').value = nfs.format(solde);

				disableBoutons(false);
			}
		}

	} catch (e) {
    recup_erreur(e);
  }
}


function endLoading2() {
  try {
    document.getElementById('Progression').collapsed = true;
		document.getElementById('pm').setAttribute('mode','none');
		disableBoutons(false);
  } catch (e) {
    recup_erreur(e);
  }
}


function init_tree() {
  try {

	  document.getElementById('Progression').collapsed = false;
		document.getElementById('pm').setAttribute('mode','undetermined');

		aBalance = new Arbre('Compta/GetRDF/balance.tmpl'+ liste_options, 'balance');
		aBalance.setParam('Like', like);
		aBalance.setParam('Type_Compte', typeCompte);
		aBalance.initTree(endLoading);

  } catch (e) {
    recup_erreur(e);
  }
}


function keypressbal(ev) {
	try {
		if (ev.keyCode==13) {
      goToCompte();
    }
	} catch (e) {
    recup_erreur(e);
  }
}


function goToCompte() {
	try {

		if (enableGoTo) {

			if (aBalance.isSelected()) {

  			var numero_compte = aBalance.getSelectedCellText('ColCompte');

   			var prec = "chrome://opensi/content/compta/user/edition/options_balance.xul?"+ cookie();
				prec += "&ListeOptions="+ urlEncode(ParamValeur("ListeOptions"));
				prec += "&Type="+ ParamValeur("Type");

      	var page = "chrome://opensi/content/compta/user/consultation/menu_consultation.xul?"+ cookie();
      	page += "&compte="+ numero_compte;
				page += "&nomprec=Balance";
      	page += "&prec="+ urlEncode(prec);
      	window.location = page;
			}
		}

	} catch (e) {
    recup_erreur(e);
  }
}
