/**********************************************************************************************/
/* OpenSi : Logiciel SaaS de gestion commerciale et comptabilit spcialis dans l'e-commerce */
/* Copyright (c) - Tous droits rservs - SAS Speedinfo Evolution                             */
/**********************************************************************************************/


jsLoader.loadSubScript("chrome://opensi/content/libs/verif.js");


function init() {
  try {

		if (ParamValeur("Type")=="Fournisseurs") {
			document.getElementById('Type').selectedItem = document.getElementById('TypeF');
		}
		else {
			document.getElementById('Type').selectedItem = document.getElementById('TypeC');
		}
		document.getElementById('Periode').selectedItem = document.getElementById('PeriodeEC');
		document.getElementById('Tri').selectedItem = document.getElementById('TriN');
		document.getElementById('Sortie').selectedItem = document.getElementById('SortieP');

  } catch (e) {
    recup_erreur(e);
  }
}

function cacheChampsMail(b) {
	try {
		document.getElementById('ChampsMail').collapsed = b;

		if (b) {
			document.getElementById('BoutonEdition').label = "EDITER LA BALANCE AGEE";
		}
		else {
			document.getElementById('BoutonEdition').label = "ENVOYER LA BALANCE AGEE";
		}

	} catch (e) {
    recup_erreur(e);
  }
}

function disableDates(b) {
	try {

		document.getElementById('Date_Fin').disabled = b;

	} catch (e) {
    recup_erreur(e);
  }
}


function retour_menu_principal() {
  try {

    window.location = "chrome://opensi/content/compta/user/menu_exercice.xul?"+ cookie();

  } catch (e) {
    recup_erreur(e);
  }
}


function updateTranche() {

	var tranche1 = document.getElementById('Tranche1').value;
	var tranche2 = document.getElementById('Tranche2').value;
	var tranche3 = document.getElementById('Tranche3').value;
	var tranche4 = document.getElementById('Tranche4').value;


	if (isEmpty(tranche1) || !isPositiveOrNull(tranche1)) {
		showWarning("Tranche 1 invalide !");
		document.getElementById('Tranche1').value = '';
		return false;
	}
	else if (isEmpty(tranche2) || !isPositiveOrNull(tranche2)) {
		showWarning("Tranche 2 invalide !");
		document.getElementById('Tranche2').value = '';
		return false;
	}
	else if (isEmpty(tranche3) || !isPositiveOrNull(tranche3)) {
		showWarning("Tranche 3 invalide !");
		document.getElementById('Tranche3').value = '';
		return false;
	}
	else if (isEmpty(tranche4) || !isPositiveOrNull(tranche4)) {
		showWarning("Tranche 4 invalide !");
		document.getElementById('Tranche4').value = '';
		return false;
	}
	else if (!(parseIntBis(tranche1) <= parseIntBis(tranche2) && parseIntBis(tranche2) <= parseIntBis(tranche3) && parseIntBis(tranche3) <= parseIntBis(tranche4))) {
		showWarning("Tranches incoh\u00E9rentes !");
		return false;
	}
	else {
		document.getElementById('Label2').value = "de "+ tranche1 +" \u00E0";
		document.getElementById('Label3').value = "de "+ tranche2 +" \u00E0";
		document.getElementById('Label4').value = "de "+ tranche3 +" \u00E0";
		document.getElementById('Label5').value = tranche4 +" jours";
		return true;
	}

}

function editerBalanceAgee() {
	try {

		var date_fin = document.getElementById('Date_Fin').value;

		if (document.getElementById('PeriodeDD').selected && !isDate(date_fin)) {
			showMessage("Date de fin invalide !");
		}
		else if(updateTranche()) {
			var liste_options = "&Date_Fin="+ date_fin;
			liste_options += "&Type="+ document.getElementById('Type').value;
			liste_options += "&Tri=" + document.getElementById('Tri').value;
			liste_options += "&Periode="+ document.getElementById('Periode').value;
			liste_options += "&Tranche1="+ document.getElementById('Tranche1').value;
			liste_options += "&Tranche2="+ document.getElementById('Tranche2').value;
			liste_options += "&Tranche3="+ document.getElementById('Tranche3').value;
			liste_options += "&Tranche4="+ document.getElementById('Tranche4').value;

			var sortie = document.getElementById('Sortie').value;

			if (sortie=="M") {

				var email = document.getElementById('Email').value;
				var sujet = document.getElementById('Sujet').value;
				var message = document.getElementById('Message').value;

				if (!isEmail(email)) {
					showMessage("Adresse e-mail incorrecte !");
				}
				else {
					var corps = cookie() + "&Page=Compta/Etats/balanceagee_pdf.tmpl&ContentType=xml&EnvoiMail=y";
          corps += liste_options+"&Email="+urlEncode(email)+"&Sujet="+urlEncode(sujet)+"&Message="+urlEncode(message);
          requeteHTTP(corps,new XMLHttpRequest(),suiteEditer);
				}
			}
			else {
				page = getUrlOpeneas("&Page=Compta/Etats/balanceagee_pdf.tmpl" + liste_options);
				document.getElementById('balanceagee').setAttribute("src", page);
				document.getElementById('deck').selectedIndex = 1;
				document.getElementById('bRetourOptions').collapsed = false;
			}
		}

	} catch (e) {
    recup_erreur(e);
  }
}
function retour_options() {
  try {

		document.getElementById('balanceagee').setAttribute("src", "");
   	document.getElementById('deck').selectedIndex = 0;
		document.getElementById('bRetourOptions').collapsed = true;

  } catch (e) {
    recup_erreur(e);
  }
}
function suiteEditer(httpRequest) {
  try {

    showMessage("La balance ag\u00E9e a \u00E9t\u00E9 envoy\u00E9e !");

	} catch (e) {
    recup_erreur(e);
  }
}
