/**********************************************************************************************/
/* OpenSi : Logiciel SaaS de gestion commerciale et comptabilit spcialis dans l'e-commerce */
/* Copyright (c) - Tous droits rservs - SAS Speedinfo Evolution                             */
/**********************************************************************************************/


jsLoader.loadSubScript("chrome://opensi/content/libs/verif.js");

var currentChampCompte;

function init() {
  try {

		document.getElementById('Type').value = "G";
		document.getElementById('Periode').selectedItem = document.getElementById('PeriodeEC');
		document.getElementById('Edition').selectedItem = document.getElementById('EditionC');
		document.getElementById('Ed_Cpte').selectedItem = document.getElementById('EdCpteT');
		document.getElementById('Ed_Ecriture').selectedItem = document.getElementById('EdEcrT');
		document.getElementById('Sortie').selectedItem = document.getElementById('SortieP');

  } catch (e) {
    recup_erreur(e);
  }
}

function cacheChampsMail(b) {
	try {
		document.getElementById('ChampsMail').collapsed = b;

		if (b) {
			document.getElementById('BoutonEdition').label = "EDITER LE GRAND LIVRE";
		}
		else {
			document.getElementById('BoutonEdition').label = "ENVOYER LE GRAND LIVRE";
		}

	} catch (e) {
    recup_erreur(e);
  }
}


function disableDates(b) {
	try {

		document.getElementById('Date_Debut').disabled = b;
		document.getElementById('Date_Fin').disabled = b;

	} catch (e) {
    recup_erreur(e);
  }
}

function disableCptes(b) {
	try {

		document.getElementById('Cpte_Debut').disabled = b;
		document.getElementById('Cpte_Fin').disabled = b;
		document.getElementById('bCpte_Debut').disabled = b;
		document.getElementById('bCpte_Fin').disabled = b;

	} catch (e) {
    recup_erreur(e);
  }
}


function rechcompte(id) {
	try {

		var typeCompte = document.getElementById('Type').value;
		var numCompte = document.getElementById(id).value;

		var titre = "";

		if (typeCompte!="T") {
    	if (typeCompte=="C") {
    		titre ="CLIENT";
    	} else if (typeCompte=="F") {
    		titre ="FOURNISSEUR";
    	} else if (typeCompte=="A") {
    		titre ="AUXILIAIRE";
			} else if (typeCompte=="G") {
    		titre ="GENERAL";
    	}
    }

		currentChampCompte = id;
    var url = "chrome://opensi/content/compta/user/comptes/popup-rechercheCompte.xul";
    window.openDialog(url,'','chrome,modal,centerscreen', retourRechCompte, numCompte, typeCompte, titre, "", "");

	} catch (e) {
		recup_erreur(e);
	}
}


function retourRechCompte(numCompte, compteId) {
	try {

		document.getElementById(currentChampCompte).value = numCompte;

	} catch (e) {
		recup_erreur(e);
	}
}


function keypress(e,id) {
  try {

    if (e.keyCode == 13){
      rechcompte(id);
    }

  } catch (e) {
    recup_erreur(e);
  }
}


function retour_menu_principal() {
  try {

    window.location = "chrome://opensi/content/compta/user/menu_exercice.xul?"+ cookie();

	} catch (e) {
    recup_erreur(e);
  }
}


function editerGrandLivre() {
	try {

		var date_debut = document.getElementById('Date_Debut').value;
		var date_fin = document.getElementById('Date_Fin').value;
		var cpte_debut = document.getElementById('Cpte_Debut').value;
		var cpte_fin = document.getElementById('Cpte_Fin').value;

		if (document.getElementById('EditionP').selected && (!isCompteCorrect(cpte_debut) || !isCompteCorrect(cpte_fin))) {
			showMessage("Num\u00E9ros de compte invalides !");
		}
		else if (document.getElementById('PeriodeDD').selected && (!isDate(date_fin) || !isDate(date_debut) || !isDateInterval(date_debut, date_fin))) {
			showMessage("Plage de dates invalide !");
		}
		else {
			var liste_options = "&Date_Debut="+ date_debut;
			liste_options += "&Date_Fin="+ date_fin;
			liste_options += "&Cpte_Debut="+ cpte_debut;
			liste_options += "&Cpte_Fin="+ cpte_fin;
			liste_options += "&Type="+ document.getElementById('Type').value;
			liste_options += "&Periode="+ document.getElementById('Periode').value;
			liste_options += "&Edition="+ document.getElementById('Edition').value;
			liste_options += "&Ed_Cpte="+ document.getElementById('Ed_Cpte').value;
			liste_options += "&Ed_Ecriture="+ document.getElementById('Ed_Ecriture').value;

			var sortie = document.getElementById('Sortie').value;

			if (sortie=="M") {

				var email = document.getElementById('Email').value;
				var sujet = document.getElementById('Sujet').value;
				var message = document.getElementById('Message').value;

				if (!isEmail(email)) {
					showMessage("Adresse e-mail incorrecte !");
				}
				else {
					var corps = cookie() + "&Page=Compta/Etats/grandlivre_pdf.tmpl&ContentType=xml&EnvoiMail=y";
          corps += liste_options+"&Email="+urlEncode(email)+"&Sujet="+urlEncode(sujet)+"&Message="+urlEncode(message);
          requeteHTTP(corps,new XMLHttpRequest(),suiteEditer);
				}
			} else if (sortie=="C") {
				var corps = cookie() + "&Page=Compta/Etats/grandlivre_csv.tmpl&ContentType=xml" + liste_options;
        requeteHTTP(corps,new XMLHttpRequest(),suiteEditerCSV);
			}
			else {
				var page = getUrlOpeneas("&Page=Compta/Etats/grandlivre_pdf.tmpl" + liste_options);
				document.getElementById('grandlivre').setAttribute("src", page);
				document.getElementById('deck').selectedIndex = 1;
				document.getElementById('bRetourOptions').collapsed = false;
			}
		}

	} catch (e) {
    recup_erreur(e);
  }
}

function retour_options() {
  try {

		document.getElementById('grandlivre').setAttribute("src", "");
   	document.getElementById('deck').selectedIndex = 0;
		document.getElementById('bRetourOptions').collapsed = true;

  } catch (e) {
    recup_erreur(e);
  }
}
function suiteEditer(httpRequest) {
  try {

    showMessage("Le grand livre a \u00E9t\u00E9 envoy\u00E9 !");

	} catch (e) {
    recup_erreur(e);
  }
}


function suiteEditerCSV(httpRequest) {
  try {

    var contenu = httpRequest.responseXML;

		var fichier_csv = contenu.documentElement.getAttribute('fichier');
		var nomFichier = formaterNomFichier("grandLivre", "csv");
		var file = fileChooser("save", nomFichier);
		if (file!=null) {
			downloadFile(getDirBuffer()+ fichier_csv, file);
		}

	} catch (e) {
    recup_erreur(e);
  }
}
