/**********************************************************************************************/
/* OpenSi : Logiciel SaaS de gestion commerciale et comptabilit spcialis dans l'e-commerce */
/* Copyright (c) - Tous droits rservs - SAS Speedinfo Evolution                             */
/**********************************************************************************************/


var ods_selDepotStock = "";
var ods_aDepotsStock = new Arbre('Config/globale/list-depotStock.tmpl', 'ods-listeDepotsStock');



function ods_init() {
	try {

		var accMWM = getProfil().isAccMWM();

		ods_filtrerDepotStock();

		var aConfExp = new Arbre('ComboListe/combo-configExpedition.tmpl', 'ods-exlConfig');
		aConfExp.initTree(ods_chargerPays);

		document.getElementById("ods-rowEtapePickingBLCC").collapsed = !adminMode || !accMWM;
		document.getElementById("ods-rowEtapePickingBLTS").collapsed = !adminMode || !accMWM;

	} catch (e) {
    recup_erreur(e);
  }
}


function ods_chargerPays() {
	try {

		var aPays = new Arbre("ComboListe/combo-pays.tmpl", "ods-codePays");
		aPays.initTree(ods_nouveauDepot);

	} catch (e) {
		recup_erreur(e);
	}
}


function ods_filtrerDepotStock() {
	try {

		ods_aDepotsStock.setParam("Actif", document.getElementById("ods-filtreActif").checked);
		ods_aDepotsStock.initTree();

	} catch (e) {
    recup_erreur(e);
  }
}


function ods_nouveauDepot() {
	try {

		ods_aDepotsStock.clearSelection();
		ods_selDepotStock = "";

		document.getElementById('ods-codeDepot').value = "";
		document.getElementById('ods-intitule').value = "";
		document.getElementById('ods-typeDepot').value = "E";
		document.getElementById('ods-fournisseurId').value = "";
		document.getElementById('ods-clientId').value = "";
		ods_pressOnTypeDepot();
		document.getElementById('ods-telephone').value = "";
		document.getElementById('ods-fax').value = "";
		document.getElementById('ods-email').value = "";
		document.getElementById('ods-actif').checked = true;
		document.getElementById('ods-denomination').value = "";
		document.getElementById('ods-adresse1').value = "";
		document.getElementById('ods-adresse2').value = "";
		document.getElementById('ods-adresse3').value = "";
		document.getElementById('ods-codePostal').value = "";
		document.getElementById('ods-ville').value = "";
		document.getElementById('ods-codePays').value = "FR";
		document.getElementById('ods-exlConfig').value = "";
		document.getElementById('ods-etapeRangementCF').value = "";
		document.getElementById('ods-etapeRangementTS').value = "";
		document.getElementById('ods-etapeRangementRF').value = "";
		document.getElementById('ods-etapePickingBLCC').value = "";
		document.getElementById('ods-etapePickingBLTS').value = "";
		document.getElementById('ods-etapePrepaBLCC').value = "";
		document.getElementById('ods-etapePrepaBLTS').value = "";
		document.getElementById('ods-etapePrepaBLRF').value = "";

		document.getElementById('ods-bSupprimerDepot').collapsed = true;
		document.getElementById('ods-bNouveauDepot').collapsed = true;

	} catch (e) {
		recup_erreur(e);
	}
}


function ods_ouvrirDepot() {
	try {

		if (ods_aDepotsStock.isSelected()) {
			var i = ods_aDepotsStock.getCurrentIndex();
			ods_selDepotStock = ods_aDepotsStock.getCellText(i, 'ods-colDepotId');

			document.getElementById('ods-codeDepot').value = ods_aDepotsStock.getCellText(i, 'ods-colCodeDepot');
			document.getElementById('ods-intitule').value = ods_aDepotsStock.getCellText(i, 'ods-colIntitule');
			document.getElementById('ods-typeDepot').value = ods_aDepotsStock.getCellText(i, 'ods-colTypeDepot');
			document.getElementById('ods-fournisseurId').value = ods_aDepotsStock.getCellText(i, 'ods-colLogisticien');
			document.getElementById('ods-clientId').value = ods_aDepotsStock.getCellText(i, 'ods-colRevendeur');
			ods_pressOnTypeDepot();
			document.getElementById('ods-telephone').value = ods_aDepotsStock.getCellText(i, 'ods-colTelephone');
			document.getElementById('ods-fax').value = ods_aDepotsStock.getCellText(i, 'ods-colFax');
			document.getElementById('ods-email').value = ods_aDepotsStock.getCellText(i, 'ods-colEmail');
			document.getElementById('ods-actif').checked = (ods_aDepotsStock.getCellText(i, 'ods-colActif')=="true");
			document.getElementById('ods-denomination').value = ods_aDepotsStock.getCellText(i, 'ods-colDenomination');
			document.getElementById('ods-adresse1').value = ods_aDepotsStock.getCellText(i, 'ods-colAdresse1');
			document.getElementById('ods-adresse2').value = ods_aDepotsStock.getCellText(i, 'ods-colAdresse2');
			document.getElementById('ods-adresse3').value = ods_aDepotsStock.getCellText(i, 'ods-colAdresse3');
			document.getElementById('ods-codePostal').value = ods_aDepotsStock.getCellText(i, 'ods-colCodePostal');
			document.getElementById('ods-ville').value = ods_aDepotsStock.getCellText(i, 'ods-colVille');
			document.getElementById('ods-codePays').value = ods_aDepotsStock.getCellText(i, 'ods-colCodePays');
			document.getElementById('ods-exlConfig').value = ods_aDepotsStock.getCellText(i, 'ods-colEXLConfig');
			document.getElementById('ods-etapeRangementCF').value = ods_aDepotsStock.getCellText(i, 'ods-colEtapeRangementCF');
			document.getElementById('ods-etapeRangementTS').value = ods_aDepotsStock.getCellText(i, 'ods-colEtapeRangementTS');
			document.getElementById('ods-etapeRangementRF').value = ods_aDepotsStock.getCellText(i, 'ods-colEtapeRangementRF');
			document.getElementById('ods-etapePickingBLCC').value = ods_aDepotsStock.getCellText(i, 'ods-colEtapePickingBLCC');
			document.getElementById('ods-etapePickingBLTS').value = ods_aDepotsStock.getCellText(i, 'ods-colEtapePickingBLTS');
			document.getElementById('ods-etapePrepaBLCC').value = ods_aDepotsStock.getCellText(i, 'ods-colEtapePrepaBLCC');
			document.getElementById('ods-etapePrepaBLTS').value = ods_aDepotsStock.getCellText(i, 'ods-colEtapePrepaBLTS');
			document.getElementById('ods-etapePrepaBLRF').value = ods_aDepotsStock.getCellText(i, 'ods-colEtapePrepaBLRF');

			document.getElementById('ods-bSupprimerDepot').collapsed = false;
			document.getElementById('ods-bNouveauDepot').collapsed = false;
		}

	} catch (e) {
		recup_erreur(e);
	}
}


function ods_enregistrerDepot() {
	try {

		var codeDepot = document.getElementById('ods-codeDepot').value;
		var intitule = document.getElementById('ods-intitule').value;
		var typeDepot = document.getElementById('ods-typeDepot').value;
		var telephone = document.getElementById('ods-telephone').value;
		var fax = document.getElementById('ods-fax').value;
		var email = document.getElementById('ods-email').value;
		var actif = document.getElementById('ods-actif').checked;
		var denomination = document.getElementById('ods-denomination').value;
		var adresse1 = document.getElementById('ods-adresse1').value;
		var adresse2 = document.getElementById('ods-adresse2').value;
		var adresse3 = document.getElementById('ods-adresse3').value;
		var codePostal = document.getElementById('ods-codePostal').value;
		var ville = document.getElementById('ods-ville').value;
		var codePays = document.getElementById('ods-codePays').value;
		var logisticien = document.getElementById('ods-fournisseurId').value;
		var revendeur = document.getElementById('ods-clientId').value;
		var exlConfig = document.getElementById('ods-exlConfig').value;
		var etapeRangementCF = document.getElementById('ods-etapeRangementCF').value;
		var etapeRangementTS = document.getElementById('ods-etapeRangementTS').value;
		var etapeRangementRF = document.getElementById('ods-etapeRangementRF').value;
		var etapePickingBLCC = document.getElementById('ods-etapePickingBLCC').value;
		var etapePickingBLTS = document.getElementById('ods-etapePickingBLTS').value;
		var etapePrepaBLCC = document.getElementById('ods-etapePrepaBLCC').value;
		var etapePrepaBLTS = document.getElementById('ods-etapePrepaBLTS').value;
		var etapePrepaBLRF = document.getElementById('ods-etapePrepaBLRF').value;

		if (isEmpty(codeDepot)) { showWarning("Veuillez saisir le code d\u00E9p\u00F4t."); }
		else if (!isCleAlpha(codeDepot)) { showWarning("Le code d\u00E9p\u00F4t ne doit pas contenir d'accents ni de caract\u00E8res sp\u00E9ciaux.") }
		else if (isEmpty(intitule)) { showWarning("Veuillez saisir l'intitul\u00E9."); }
		else if (typeDepot=="L" && isEmpty(logisticien)) { showWarning("Veuillez choisir un logisticien."); }
		else if (typeDepot=="V" && isEmpty(revendeur)) { showWarning("Veuillez choisir un revendeur."); }
		else if (!isEmpty(telephone) && !isPhone(telephone)) { showWarning("Le t\u00E9l\u00E9phone est incorrect."); }
		else if (!isEmpty(fax) && !isPhone(fax)) { showWarning("Le fax est incorrect."); }
		else if (!isEmpty(email) && !isEmail(email)) { showWarning("L'e-mail est incorrect."); }
		else if (isEmpty(denomination)) { showWarning("Veuillez saisir la d\u00E9nomination."); }
		else if (isEmpty(adresse1)) { showWarning("Veuillez saisir l'adresse."); }
		else if (isEmpty(ville)) { showWarning("Veuillez saisir la ville."); }
		else {

			var qEnregistrer;
			if (isEmpty(ods_selDepotStock)) {
				qEnregistrer = new QueryHttp("Config/globale/createDepotStock.tmpl");
			}
			else {
				qEnregistrer = new QueryHttp("Config/globale/updateDepotStock.tmpl");
				qEnregistrer.setParam("Depot_Id", ods_selDepotStock);
			}
			qEnregistrer.setParam("Code_Depot", codeDepot);
			qEnregistrer.setParam("Intitule", intitule);
			qEnregistrer.setParam("Type_Depot", typeDepot);
			if (typeDepot=="L") { qEnregistrer.setParam("Logisticien", logisticien); }
			else if (typeDepot=="V") { qEnregistrer.setParam("Revendeur", revendeur); }
			qEnregistrer.setParam("Telephone", telephone);
			qEnregistrer.setParam("Fax", fax);
			qEnregistrer.setParam("Email", email);
			qEnregistrer.setParam("Actif", actif);
			qEnregistrer.setParam("Denomination", denomination);
			qEnregistrer.setParam("Adresse_1", adresse1);
			qEnregistrer.setParam("Adresse_2", adresse2);
			qEnregistrer.setParam("Adresse_3", adresse3);
			qEnregistrer.setParam("Code_Postal", codePostal);
			qEnregistrer.setParam("Ville", ville);
			qEnregistrer.setParam("Code_Pays", codePays);
			qEnregistrer.setParam("EXL_Config", exlConfig);
			qEnregistrer.setParam("Etape_Rangement_CF", etapeRangementCF);
			qEnregistrer.setParam("Etape_Rangement_TS", etapeRangementTS);
			qEnregistrer.setParam("Etape_Rangement_RF", etapeRangementRF);
			qEnregistrer.setParam("Etape_Picking_BL_CC", etapePickingBLCC);
			qEnregistrer.setParam("Etape_Picking_BL_TS", etapePickingBLTS);
			qEnregistrer.setParam("Etape_Prepa_BL_CC", etapePrepaBLCC);
			qEnregistrer.setParam("Etape_Prepa_BL_TS", etapePrepaBLTS);
			qEnregistrer.setParam("Etape_Prepa_BL_RF", etapePrepaBLRF);

			var result = qEnregistrer.execute();
			var errors = new Errors(result);

			if (errors.hasNext()) {
				errors.show();
			}
			else {
				var message = result.responseXML.documentElement.getAttribute('Message');
				if (message!=null) {
					showWarning(message);
				}
				ods_filtrerDepotStock();
				ods_nouveauDepot();
			}
		}

	} catch (e) {
		recup_erreur(e);
	}
}


function ods_supprimerDepot() {
	try {

		if (window.confirm("Voulez-vous supprimer le d\u00E9p\u00F4t s\u00E9lectionn\u00E9 ?")) {
			var qSupprimer = new QueryHttp("Config/globale/deleteDepotStock.tmpl");
			qSupprimer.setParam("Depot_Id", ods_selDepotStock);
			var result = qSupprimer.execute();

			var errors = new Errors(result);
			if (errors.hasNext()) {
				errors.show();
			}
			else {
				ods_filtrerDepotStock();
				ods_nouveauDepot();
			}
		}

	} catch (e) {
		recup_erreur(e);
	}
}


function ods_reporterAdresse() {
	try {

		var typeDepot = document.getElementById('ods-typeDepot').value;
		var logisticien = document.getElementById('ods-fournisseurId').value;
		var revendeur = document.getElementById('ods-clientId').value;

		if (typeDepot=="L" && isEmpty(logisticien)) { showWarning("Veuillez d'abord choisir un logisticien."); }
		else if (typeDepot=="V" && isEmpty(revendeur)) { showWarning("Veuillez d'abord choisir un revendeur."); }
		else {
			var qReporterAdr = new QueryHttp("Config/globale/prefillAdresseDepotStock.tmpl");
			qReporterAdr.setParam("Type_Depot", typeDepot);
			if (typeDepot=="L") { qReporterAdr.setParam("Logisticien", logisticien); }
			else if (typeDepot=="V") { qReporterAdr.setParam("Revendeur", revendeur); }
			var result = qReporterAdr.execute();
			var contenu = result.responseXML.documentElement;

			document.getElementById('ods-denomination').value = contenu.getAttribute("Denomination");
			document.getElementById('ods-adresse1').value = contenu.getAttribute("Adresse_1");
			document.getElementById('ods-adresse2').value = contenu.getAttribute("Adresse_2");
			document.getElementById('ods-adresse3').value = contenu.getAttribute("Adresse_3");
			document.getElementById('ods-codePostal').value = contenu.getAttribute("Code_Postal");
			document.getElementById('ods-ville').value = contenu.getAttribute("Ville");
			document.getElementById('ods-codePays').value = contenu.getAttribute("Code_Pays");
		}

	} catch (e) {
		recup_erreur(e);
	}
}


function ods_rechercherClient() {
	try {

		var url = "chrome://opensi/content/facturation/user/clients/popup-rechercheClient.xul";
    window.openDialog(url,'','chrome,modal,centerscreen', ods_retourRechercherClient);

	} catch (e) {
		recup_erreur(e);
	}
}


function ods_retourRechercherClient(codeClient) {
	try {

  	document.getElementById('ods-clientId').value = codeClient;

	} catch (e) {
		recup_erreur(e);
	}
}


function ods_rechercherFourn() {
	try {

		var url = "chrome://opensi/content/facturation/user/fournisseurs/popup-rechercheFournisseur.xul";
    window.openDialog(url,'','chrome,modal,centerscreen', ods_retourRechercherFourn);

	} catch (e) {
		recup_erreur(e);
	}
}


function ods_retourRechercherFourn(codeFourn) {
	try {

  	document.getElementById('ods-fournisseurId').value = codeFourn;

	} catch (e) {
		recup_erreur(e);
	}
}


function ods_pressOnTypeDepot() {
	try {

		var typeDepot = document.getElementById('ods-typeDepot').value;
		document.getElementById('ods-logisticien').collapsed = (typeDepot!="L");
		document.getElementById('ods-revendeur').collapsed = (typeDepot!="V");
		document.getElementById('ods-lblEtapeCC').collapsed = (typeDepot=="L");
		document.getElementById('ods-lblEtapeOL').collapsed = (typeDepot!="L");

	} catch (e) {
		recup_erreur(e);
	}
}
