/**********************************************************************************************/
/* OpenSi : Logiciel SaaS de gestion commerciale et comptabilit spcialis dans l'e-commerce */
/* Copyright (c) - Tous droits rservs - SAS Speedinfo Evolution                             */
/**********************************************************************************************/

var oecol_aColis = new Arbre("Facturation/Affaires/list-colisCB.tmpl", "oecol-listeColis");
var oecol_aHorsColis = new Arbre("Facturation/Affaires/list-horsColisCB.tmpl", "oecol-horsColis");
var oecol_aContenuColis = new Arbre("Facturation/Affaires/list-contenuColisCB.tmpl", "oecol-contenuColis");

var oecol_qEtiquettes = new QueryHttp("Facturation/Affaires/pdfEtiquettes.tmpl");
var oecol_qCalculColisage = new QueryHttp("Facturation/Affaires/calculColisage.tmpl");


var oecol_colisId = 0;
var oecol_autEtiq = false;



function oecol_init() {
  try {

		oecol_colisId = 0;
		oecol_disableRetirer(true);
		oecol_disableAjouter(true);

		var qGet = new QueryHttp("Facturation/Affaires/getNbColisSuivi.tmpl");
		qGet.setParam("Bon_Id", bonId);
		var result = qGet.execute();
		document.getElementById("oecol-bCalculColisage").disabled = result.responseXML.documentElement.getAttribute('NbColis')>0;

		oecol_qCalculColisage.setParam("Bon_Id", bonId);

		oecol_aColis.setParam("Bon_Liv_Id", bonId);
		oecol_aColis.initTree(oecol_calcColis);

		oecol_aHorsColis.setParam("Bon_Liv_Id", bonId);
		oecol_aHorsColis.initTree();

		oecol_nouveauColis();

		document.getElementById("bRetourExpedition").collapsed = false;

		if (gReadOnly) {
			document.getElementById("oecol-boxActions").collapsed = true;
			document.getElementById("oecol-bCalculColisage").collapsed = true;
			document.getElementById("oecol-bNouveauColis").collapsed = true;
		}

  } catch (e) {
    recup_erreur(e);
  }
}


function oecol_nouveauColis() {
	try {

		oecol_aContenuColis.deleteTree();
		oecol_colisId = 0;
		document.getElementById('oecol-lblContenu').value = "Nouveau colis :";

	} catch (e) {
    recup_erreur(e);
  }
}


function oecol_reporterQteEntree() {
	try {

		if (oecol_aHorsColis.isSelected()) {
			if (oecol_aHorsColis.nbSelection()==1) {
				document.getElementById("oecol-QteEntree").value = oecol_aHorsColis.getSelectedCellText('oecol-colQuantiteHC');
				document.getElementById("oecol-QteEntree").disabled = false;
				var poidsUnit = oecol_aHorsColis.getSelectedCellText('oecol-colPoidsHC');
				document.getElementById("oecol-PoidsEntree").value = poidsUnit;
				document.getElementById('oecol-PoidsEntree').disabled = !isEmpty(poidsUnit);
				oecol_disableAjouter(false);
			}
			else {
				document.getElementById("oecol-QteEntree").value = "";
				document.getElementById("oecol-QteEntree").disabled = true;
				document.getElementById("oecol-PoidsEntree").value = "";
				document.getElementById('oecol-PoidsEntree').disabled = true;
				document.getElementById('oecol-bAjouter').disabled = false;
			}
			oecol_disableRetirer(true);
		}

	} catch (e) {
    recup_erreur(e);
  }
}


function oecol_reporterQteSortie() {
	try {

		if (oecol_aContenuColis.isSelected()) {
			document.getElementById("oecol-QteSortie").value = oecol_aContenuColis.getSelectedCellText('oecol-colQuantite');
			oecol_disableRetirer(false);
			oecol_disableAjouter(true);
		}

	} catch (e) {
    recup_erreur(e);
  }
}


function oecol_disableAjouter(b) {
	try {
		document.getElementById('oecol-bAjouter').disabled = b;
		document.getElementById('oecol-QteEntree').disabled = b;
		document.getElementById('oecol-PoidsEntree').disabled = b;
	} catch (e) {
    recup_erreur(e);
  }
}


function oecol_disableRetirer(b) {
	try {
		document.getElementById('oecol-bRetirer').disabled = b;
		document.getElementById('oecol-QteSortie').disabled = b;
	} catch (e) {
    recup_erreur(e);
  }
}


function oecol_calculColisage() {
	try {

		oecol_qCalculColisage.execute();
		oecol_aHorsColis.initTree();
		oecol_aColis.initTree(oecol_calcColis);
		oecol_nouveauColis();

	} catch (e) {
    recup_erreur(e);
  }
}


function oecol_ajouterAuColis() {
	try {

		if (oecol_aHorsColis.isSelected()) {

			var qAdd = new QueryHttp("Facturation/Affaires/ajouterArticleColis.tmpl");

			if (oecol_aHorsColis.nbSelection()==1) {
				var refLigne = oecol_aHorsColis.getSelectedCellValue('oecol-colReferenceHC');
				var qteinit = oecol_aHorsColis.getSelectedCellText('oecol-colQuantiteHC');
				var poids = document.getElementById("oecol-PoidsEntree").value;
				var quantite = document.getElementById("oecol-QteEntree").value;

				if (isEmpty(quantite)) {
					showWarning("Veuillez entrer une quantit\u00E9 \u00E0 transf\u00E9rer");
				}
				else if (!checkQte(quantite)) {
					showWarning("Quantit\u00E9 incorrecte !");
				}
				else if (parseFloat(qteinit)-parseFloat(quantite)<0) {
					showWarning("La quantit\u00E9 \u00E0 transf\u00E9rer d\u00E9passe la quantit\u00E9 restant \u00E0 livrer !");
				}
				else if (isEmpty(poids)) {
					showWarning("Veuillez entrer un poids unitaire pour cet article !");
				}
				else if (!isPositiveOrNull(poids) || !checkDecimal(poids,3)) {
					showWarning("Poids unitaire incorrect !");
				}
				else {
					oecol_disableAjouter(true);

					qAdd.setParam("Colis_Id", oecol_colisId);
					qAdd.setParam("Ref_Ligne", refLigne);
					qAdd.setParam("Quantite", quantite);
					qAdd.setParam("Poids", poids);
					qAdd.setParam("Bon_Id", bonId);
					qAdd.execute(oecol_ajouterAuColis_2);
				}
			}
			else {
				var liste = "";
				var rangeCount = oecol_aHorsColis.getRangeCount();

				for (var j=0; j<rangeCount; j++) {
					var start = {};
					var end = {};
					oecol_aHorsColis.getRangeAt(j,start,end);

					for (var c=start.value; c<=end.value; c++) {
						if (!isEmpty(liste)) { liste += ",";  }

						var poids = oecol_aHorsColis.getCellText(c, 'oecol-colPoidsHC');
						if (isEmpty(poids)) {
							poids = 0;
						}
						liste += oecol_aHorsColis.getCellValue(c, 'oecol-colReferenceHC') +";"+ oecol_aHorsColis.getCellText(c, 'oecol-colQuantiteHC') +";"+ poids;
					}
				}
				oecol_disableAjouter(true);

				qAdd.setParam("List_Ligne_Id", liste);
				qAdd.setParam("Colis_Id", oecol_colisId);
				qAdd.setParam("Bon_Id", bonId);
				qAdd.execute(oecol_ajouterAuColis_2);
			}
		}

	} catch (e) {
    recup_erreur(e);
  }
}


function oecol_ajouterAuColis_2(result) {
	try {

		if (oecol_colisId==0) {
			oecol_colisId = result.responseXML.documentElement.getAttribute("Colis_Id");
			document.getElementById('oecol-lblContenu').value = "Contenu du colis n\u00B0 "+ oecol_colisId;
		}
		oecol_aContenuColis.setParam("Colis_Id", oecol_colisId);
		oecol_aContenuColis.initTree();
		oecol_aHorsColis.initTree();
		oecol_aColis.initTree(oecol_calcColis);

	} catch (e) {
    recup_erreur(e);
  }
}


function oecol_retirerAuColis() {
  try {

		if (oecol_aContenuColis.isSelected()) {

			var ref_ligne = oecol_aContenuColis.getSelectedCellValue('oecol-colReference');
			var qteinit = oecol_aContenuColis.getSelectedCellText('oecol-colQuantite');
			var poids = oecol_aContenuColis.getSelectedCellText('oecol-colPoids');
			if (isEmpty(poids)) poids = 0;
			var quantite = document.getElementById("oecol-QteSortie").value;

			if (isEmpty(quantite)) {
				showWarning("Veuillez entrer une quantit\u00E9 \u00E0 enlever");
			}
			else if (!checkQte(quantite)) {
				showWarning("Quantit\u00E9 incorrecte !");
			}
			else if (parseFloat(qteinit)-parseFloat(quantite)<0) {
				showWarning("La quantit\u00E9 \u00E0 enlever ne peut d\u00E9passer la quantit\u00E9 pr\u00E9sente dans le colis !");
			}
			else {
				oecol_disableRetirer(true);

				var qUpdate = new QueryHttp("Facturation/Affaires/enleverArticleColis.tmpl");
				qUpdate.setParam("Colis_Id", oecol_colisId);
				qUpdate.setParam("Ref_Ligne", ref_ligne);
				qUpdate.setParam("QteInit", qteinit);
				qUpdate.setParam("Quantite", quantite);
				qUpdate.setParam("Poids", poids);

				qUpdate.execute(oecol_retirerAuColis_2);
			}
		}

	} catch (e) {
  	recup_erreur(e);
	}
}


function oecol_retirerAuColis_2(result) {
  try {

		if (result.responseXML.documentElement.getAttribute("vide")=="y") {
			oecol_nouveauColis();
		}
		else {
			oecol_aContenuColis.setParam("Colis_Id", oecol_colisId);
			oecol_aContenuColis.initTree();
		}
		oecol_aHorsColis.initTree();
		oecol_aColis.initTree(oecol_calcColis);

	} catch (e) {
  	recup_erreur(e);
	}
}


function oecol_afficherContenu() {
	try {

		if (oecol_aColis.isSelected()) {
			oecol_colisId = oecol_aColis.getSelectedCellText('oecol-colColisId');
			document.getElementById('oecol-lblContenu').value = "Contenu du colis n\u00B0 "+ oecol_aColis.getSelectedCellText('oecol-colNumInterne') +" :";
			oecol_aContenuColis.setParam("Colis_Id", oecol_colisId);
			oecol_aContenuColis.initTree();
		}

	} catch (e) {
    recup_erreur(e);
  }
}

function oecol_demandeEnregistrement() {
	try {

	} catch (e) {
    recup_erreur(e);
  }
}

function oecol_calcColis() {
	try {

		if (oecol_aColis.isNotNull()) {

			var nbColis = oecol_aColis.nbLignes();
			document.getElementById('oecol-nbColis').value = nbColis;
			document.getElementById('oebl-nbColis').value = nbColis;

			var pt = 0;

			for (var i=0;i<oecol_aColis.nbLignes();i++) {
				pt += parseFloat(oecol_aColis.getCellText(i, 'oecol-colPoidsColis'));
			}
			var nf = new NumberFormat("0.##", false);
			document.getElementById('oecol-poidsTotal').value = nf.format(pt);
		}

		oecol_autEtiq = (parseIntBis(document.getElementById('oecol-nbColis').value)>0);

	} catch (e) {
    recup_erreur(e);
  }
}


function oecol_editerEtiquettesSans() {
	try {

		var oecol_nbEtiquettes = document.getElementById('oecol-nbEtiquettes').value;

		if (isEmpty(oecol_nbEtiquettes) || !isPositiveInteger(oecol_nbEtiquettes)) {
			showWarning("Nombre d'\u00E9tiquettes incorrect");
		}
		else {
			document.getElementById("oecol-deckColisageEtiquettes").selectedIndex = 1;
			oecol_qEtiquettes.setParam("Bon_Liv_Id", bonId);
			oecol_qEtiquettes.setParam("Nb_Etiquettes", oecol_nbEtiquettes);
			var result = oecol_qEtiquettes.execute();
			var page = getDirPdf() + result.responseXML.documentElement.getAttribute('fichier');
			document.getElementById('oecol-pdfColisageEtiquettes').setAttribute("src", page);
			document.getElementById("bRetourColisage").collapsed = false;
		}

	} catch (e) {
    recup_erreur(e);
  }
}

function oecol_editerEtiquettes() {
	try {

		if (oecol_autEtiq) {
			document.getElementById("oecol-deckColisageEtiquettes").selectedIndex = 1;
			oecol_qEtiquettes.setParam("Bon_Liv_Id", bonId);
			var result = oecol_qEtiquettes.execute();
			var page = getDirPdf() + result.responseXML.documentElement.getAttribute('fichier');
			document.getElementById('oecol-pdfColisageEtiquettes').setAttribute("src", page);
			document.getElementById("bRetourColisage").collapsed = false;
		}
		else {
			showWarning("Vous devez avoir au moins un colis pour pouvoir g\u00E9n\u00E9rer des etiquettes");
		}

	} catch (e) {
    recup_erreur(e);
  }
}


function oecol_editerColis() {
	try {

		if (oecol_autEtiq) {
			document.getElementById("oecol-deckColisageEtiquettes").selectedIndex = 1;

			var qEditionPDF = new QueryHttp("Facturation/Affaires/pdfListeColis.tmpl");
			qEditionPDF.setParam("Bon_Id", bonId);
			var result = qEditionPDF.execute();
			var page = getDirPdf() + result.responseXML.documentElement.getAttribute('FichierPDF');
			document.getElementById('oecol-pdfColisageEtiquettes').setAttribute("src", page);
			document.getElementById("bRetourColisage").collapsed = false;
		}
		else {
			showWarning("Vous devez avoir au moins un colis pour pouvoir g\u00E9n\u00E9rer la liste des colis");
		}

	} catch (e) {
    recup_erreur(e);
  }
}

