/**********************************************************************************************/
/* OpenSi : Logiciel SaaS de gestion commerciale et comptabilit spcialis dans l'e-commerce */
/* Copyright (c) - Tous droits rservs - SAS Speedinfo Evolution                             */
/**********************************************************************************************/

jsLoader.loadSubScript("chrome://opensi/content/libs/arbres.js");
jsLoader.loadSubScript("chrome://opensi/content/libs/verif.js");
jsLoader.loadSubScript("chrome://opensi/content/libs/query.js");


var aProfils = new Arbre('Utilisateurs/Profils/list-profilType.tmpl', 'liste-profils');

var currentProfilId = "";

var ofu_accFlash;
var ofu_accMWMExpMonoBL;
var ofu_accMWMExpMultiBL;
var ofu_accMWMCdeClient;
var ofu_specLHGDV;
var ofu_specLHGRV;
var ofu_specLHGPV;
var ofu_specLHCFF;
var ofu_specLCARAP;
var ofu_specTNMPA;
var ofu_specLVPBFC;
var ofu_accCrossDock;



function init() {
	try {

		var qEntMWM = new QueryHttp("Utilisateurs/getEntrepriseAccMWM.tmpl");
		var result = qEntMWM.execute();
		var contenu = result.responseXML.documentElement;

		ofu_accFlash = contenu.getAttribute("Acc_MWM")=="true";
	  ofu_accMWMExpMonoBL = contenu.getAttribute("Acc_MWM_ExpMonoBL")=="true";
	  ofu_accMWMExpMultiBL = contenu.getAttribute("Acc_MWM_ExpMultiBL")=="true";
	  ofu_accMWMCdeClient = contenu.getAttribute("Acc_MWM_CdeClient")=="true";
	  ofu_specLHGDV = contenu.getAttribute("Spec_LH_GDV")=="true";
	  ofu_specLHGRV = contenu.getAttribute("Spec_LH_GRV")=="true";
	  ofu_specLHGPV = contenu.getAttribute("Spec_LH_GPV")=="true";
	  ofu_specLHCFF = contenu.getAttribute("Spec_LH_CFF")=="true";
	  ofu_specLCARAP = contenu.getAttribute("Spec_LCA_RAP")=="true";
	  ofu_specTNMPA = contenu.getAttribute("Spec_TN_MPA")=="true";
	  ofu_specLVPBFC = contenu.getAttribute("Spec_LVP_BFC")=="true";
	  ofu_accCrossDock = contenu.getAttribute("Acc_Cross_Dock")=="true";

		document.getElementById("cFlash").collapsed = !ofu_accFlash;
		document.getElementById("tabFlash").collapsed = !ofu_accFlash;
		document.getElementById("cMWM_ExpMonoBL").collapsed = !ofu_accMWMExpMonoBL;
		document.getElementById("cMWM_ExpMultiBL").collapsed = !ofu_accMWMExpMultiBL;
		document.getElementById("cMWM_CdeClient").collapsed = !ofu_accMWMCdeClient;
		document.getElementById("cGestionIntiVente").collapsed = !ofu_specLHGDV;
		document.getElementById("rowGestionIntiVente").collapsed = !ofu_specLHGDV;
		document.getElementById("cGestionRespVente").collapsed = !ofu_specLHGRV;
		document.getElementById("rowGestionRespVente").collapsed = !ofu_specLHGRV;
		document.getElementById("cGestionPoleVente").collapsed = !ofu_specLHGPV;
		document.getElementById("rowGestionPoleVente").collapsed = !ofu_specLHGPV;
		document.getElementById("cGC_AControle").collapsed = !ofu_specLHCFF;
		document.getElementById("rowRestricAccCDVPA").collapsed = !ofu_specLCARAP;
		document.getElementById("cModifPrixFA").collapsed = !ofu_specTNMPA;
		document.getElementById("rowModifPrixFA").collapsed = !ofu_specTNMPA;
		document.getElementById("cMWM_LocCrossDock").collapsed = !ofu_accCrossDock;
		document.getElementById("cMWM_ExpCrossDock").collapsed = !ofu_accCrossDock;
		document.getElementById("cGC_EExpCrossDock").collapsed = !ofu_accCrossDock;
		document.getElementById("cGestionBloqueCli").collapsed = !ofu_specLVPBFC;
		document.getElementById("rowGestionBloqueCli").collapsed = !ofu_specLVPBFC;

		nouveauProfil();

	} catch (e) {
    recup_erreur(e);
  }
}


function nouveauProfil() {
	try {

		aProfils.initTree();

		document.getElementById("Intitule").value = "";
		document.getElementById("Commentaires").value = "";
		document.getElementById("cMaxValidationDC").value = "";
		document.getElementById("cModifElemFinFCA").disabled = true;

		cocherDG(false);
		cocherGC(false);
		cocherCompta(false);
		cocherMWM(false);

		document.getElementById("cReadOnlyGC_SArticles").checked = false;
		document.getElementById("cReadOnlyGC_VDevis").checked = false;
		document.getElementById("cReadOnlyGC_VAffaires").checked = false;
		document.getElementById("cReadOnlyGC_TClients").checked = false;
		document.getElementById("cReadOnlyGC_SIOStocks").checked = false;
		document.getElementById("cReadOnlyGC_DRegCli").checked = false;

		currentProfilId = "";

		document.getElementById("bSupprimer").disabled = true;
		document.getElementById("onglets").selectedIndex = 0;

	} catch (e) {
    recup_erreur(e);
  }
}


function dblClickOnProfil() {
	try {

		if (aProfils.isSelected()) {
			currentProfilId = aProfils.getSelectedCellText('ColProfilId');

			var qGetProfil = new QueryHttp("Utilisateurs/Profils/loadProfilType.tmpl")
			qGetProfil.setParam("Profil_Id", currentProfilId);

			var result = qGetProfil.execute();
			var errors = new Errors(result);

			if (errors.hasNext()) {
				errors.show();
			}
			else {
				var contenu = result.responseXML.documentElement;

				document.getElementById('Intitule').value = contenu.getAttribute("Intitule");
				document.getElementById('Commentaires').value = contenu.getAttribute("Commentaires");

				// Droits gnraux
				document.getElementById("cConfig").checked = contenu.getAttribute("Acc_Config")=="true";
				document.getElementById("cGestionCo").checked = contenu.getAttribute("Acc_Gest_Com")=="true";
				document.getElementById("cCompta").checked = contenu.getAttribute("Acc_Compta")=="true";
				document.getElementById("cContact").checked = contenu.getAttribute("Acc_CRM")=="true";
				document.getElementById("cTransac").checked = contenu.getAttribute("Acc_TB")=="true";
				document.getElementById("cFlash").checked = contenu.getAttribute("Acc_MWM")=="true";
				document.getElementById("cDirection").checked = contenu.getAttribute("Direction")=="true";
				document.getElementById("cValidationCF").checked = contenu.getAttribute("Validation_CF")=="true";
				document.getElementById("cValidationCC").checked = contenu.getAttribute("Validation_CC")=="true";
				document.getElementById("cValidationCCZero").checked = contenu.getAttribute("Validation_CC_Zero")=="true";
				document.getElementById("cAnnulationCC").checked = contenu.getAttribute("Annulation_CC")=="true";
				document.getElementById("cValidationTS").checked = contenu.getAttribute("Validation_TS")=="true";
				document.getElementById("cValidationIS").checked = contenu.getAttribute("Validation_IS")=="true";
				document.getElementById("cValidationRG").checked = contenu.getAttribute("Validation_RG")=="true";
				document.getElementById("cValidationBR").checked = contenu.getAttribute("Validation_BR")=="true";
				document.getElementById("cValidationAF").checked = contenu.getAttribute("Validation_AF")=="true";
				document.getElementById("cValidationAC").checked = contenu.getAttribute("Validation_AC")=="true";
				document.getElementById("cValidationBP").checked = contenu.getAttribute("Validation_BP")=="true";
				document.getElementById("cAnnulationBP").checked = contenu.getAttribute("Annulation_BP")=="true";
				document.getElementById("cValidationBL").checked = contenu.getAttribute("Validation_BL")=="true";
				document.getElementById("cAnnulationBL").checked = contenu.getAttribute("Annulation_BL")=="true";
				document.getElementById("cValidationDC").checked = contenu.getAttribute("Validation_DC")=="true";
				document.getElementById("cMaxValidationDC").value = contenu.getAttribute("Max_Validation_DC");
				document.getElementById("cClotureFact").checked = contenu.getAttribute("Cloture_Fact")=="true";
				document.getElementById("cModifElemFinDV").checked = contenu.getAttribute("Modif_Elem_Fin_DV")=="true";
				document.getElementById("cModifElemFinFCA").checked = contenu.getAttribute("Modif_Elem_Fin_FCA")=="true";
				document.getElementById("cIgnorePVPlancher").checked = contenu.getAttribute("Ignore_PV_Plancher")=="true";
				document.getElementById("cEditionListeDL").checked = contenu.getAttribute("Edition_Liste_DL")=="true";
				document.getElementById("cEditionListeDA").checked = contenu.getAttribute("Edition_Liste_DA")=="true";
				document.getElementById("cEditionListeDV").checked = contenu.getAttribute("Edition_Liste_DV")=="true";
				document.getElementById("cShowTotauxDV").checked = contenu.getAttribute("Show_Totaux_DV")=="true";
				document.getElementById("cAccesCoutAchat").checked = contenu.getAttribute("Acces_Cout_Achat")=="true";
				document.getElementById("cAccesCoordBanque").checked = contenu.getAttribute("Acces_Coord_Banque")=="true";
				document.getElementById("cRestricAccCDVPA").checked = contenu.getAttribute("Restric_Acc_CDV_PA")=="true";
				document.getElementById("cGestionDevisType").checked = contenu.getAttribute("Gestion_Devis_Type")=="true";
				document.getElementById("cGestionRespVente").checked = contenu.getAttribute("Gestion_Resp_Vente")=="true";
				document.getElementById("cGestionPoleVente").checked = contenu.getAttribute("Gestion_Pole_Vente")=="true";
				document.getElementById("cGestionIntiVente").checked = contenu.getAttribute("Gestion_Inti_Vente")=="true";
				document.getElementById("cGestionBloqueCli").checked = contenu.getAttribute("Gestion_Bloque_Cli")=="true";
				document.getElementById("cModifStockES").checked = contenu.getAttribute("Modif_Stock_ES")=="true";
				document.getElementById("cModifPrixFA").checked = contenu.getAttribute("Modif_Prix_FA")=="true";
				document.getElementById("cAnonymisationFC").checked = contenu.getAttribute("Anonymisation_FC")=="true";

				// Accs menus gestion commerciale
				document.getElementById("cGC_TClients").checked = contenu.getAttribute("MenuGC_TClients")=="true";
				document.getElementById("cReadOnlyGC_TClients").checked = contenu.getAttribute("ReadOnlyGC_TClients")=="true";
				document.getElementById("cGC_VDevis").checked = contenu.getAttribute("MenuGC_VDevis")=="true";
				document.getElementById("cGC_ACommandes").checked = contenu.getAttribute("MenuGC_ACommandes")=="true";
				document.getElementById("cGC_SArticles").checked = contenu.getAttribute("MenuGC_SArticles")=="true";
				document.getElementById("cReadOnlyGC_SArticles").checked = contenu.getAttribute("ReadOnlyGC_SArticles")=="true";
				document.getElementById("cGC_DRegFour").checked = contenu.getAttribute("MenuGC_DRegFour")=="true";
				document.getElementById("cGC_TFournisseurs").checked = contenu.getAttribute("MenuGC_TFournisseurs")=="true";
				document.getElementById("cGC_VAffaires").checked = contenu.getAttribute("MenuGC_VAffaires")=="true";
				document.getElementById("cReadOnlyGC_VDevis").checked = contenu.getAttribute("ReadOnlyGC_VDevis")=="true";
				document.getElementById("cReadOnlyGC_VAffaires").checked = contenu.getAttribute("ReadOnlyGC_VAffaires")=="true";
				document.getElementById("cGC_APrepaCom").checked = contenu.getAttribute("MenuGC_APrepaCom")=="true";
				document.getElementById("cGC_STarifs").checked = contenu.getAttribute("MenuGC_STarifs")=="true";
				document.getElementById("cGC_DRegCli").checked = contenu.getAttribute("MenuGC_DRegCli")=="true";
				document.getElementById("cReadOnlyGC_DRegCli").checked = contenu.getAttribute("ReadOnlyGC_DRegCli")=="true";
				document.getElementById("cGC_TCommerciaux").checked = contenu.getAttribute("MenuGC_TCommerciaux")=="true";
				document.getElementById("cGC_ARecepCom").checked = contenu.getAttribute("MenuGC_ARecepCom")=="true";
				document.getElementById("cGC_SFabrication").checked = contenu.getAttribute("MenuGC_SFabrication")=="true";
				document.getElementById("cGC_DRemises").checked = contenu.getAttribute("MenuGC_DRemises")=="true";
				document.getElementById("cGC_ARetours").checked = contenu.getAttribute("MenuGC_ARetours")=="true";
				document.getElementById("cGC_SInventaire").checked = contenu.getAttribute("MenuGC_SInventaire")=="true";
				document.getElementById("cGC_DEditions").checked = contenu.getAttribute("MenuGC_DEditions")=="true";
				document.getElementById("cGC_AFactures").checked = contenu.getAttribute("MenuGC_AFactures")=="true";
				document.getElementById("cGC_AControle").checked = contenu.getAttribute("MenuGC_AControle")=="true";
				document.getElementById("cGC_STracabilite").checked = contenu.getAttribute("MenuGC_STracabilite")=="true";
				document.getElementById("cGC_DTabBord").checked = contenu.getAttribute("MenuGC_DTabBord")=="true";
				document.getElementById("cGC_VFactures").checked = contenu.getAttribute("MenuGC_VFactures")=="true";
				document.getElementById("cGC_VRetours").checked = contenu.getAttribute("MenuGC_VRetours")=="true";
				document.getElementById("cGC_STransferts").checked = contenu.getAttribute("MenuGC_STransferts")=="true";
				document.getElementById("cGC_DTransCpta").checked = contenu.getAttribute("MenuGC_DTransCpta")=="true";
				document.getElementById("cGC_VFactuAuto").checked = contenu.getAttribute("MenuGC_VFactuAuto")=="true";
				document.getElementById("cGC_SMouvements").checked = contenu.getAttribute("MenuGC_SMouvements")=="true";
				document.getElementById("cGC_SEmplacements").checked = contenu.getAttribute("MenuGC_SEmplacements")=="true";
				document.getElementById("cGC_STransEmp").checked = contenu.getAttribute("MenuGC_STransEmp")=="true";
				document.getElementById("cGC_SIOStocks").checked = contenu.getAttribute("MenuGC_SIOStocks")=="true";
				document.getElementById("cReadOnlyGC_SIOStocks").checked = contenu.getAttribute("ReadOnlyGC_SIOStocks")=="true";
				document.getElementById("cGC_SParamStocks").checked = contenu.getAttribute("MenuGC_SParamStocks")=="true";
				document.getElementById("cGC_DExportIdep").checked = contenu.getAttribute("MenuGC_DExportIdep")=="true";
				document.getElementById("cGC_DDeclEcoPart").checked = contenu.getAttribute("MenuGC_DDeclEcoPart")=="true";
				document.getElementById("cGC_VEnvoiFact").checked = contenu.getAttribute("MenuGC_VEnvoiFact")=="true";
				document.getElementById("cGC_DImpExpCsv").checked = contenu.getAttribute("MenuGC_DImpExpCsv")=="true";
				document.getElementById("cGC_VAbonnements").checked = contenu.getAttribute("MenuGC_VAbonnements")=="true";
				document.getElementById("cGC_DPassword").checked = contenu.getAttribute("MenuGC_DPassword")=="true";
				document.getElementById("cGC_EExpesCC").checked = contenu.getAttribute("MenuGC_EExpesCC")=="true";
				document.getElementById("cGC_EExpesTS").checked = contenu.getAttribute("MenuGC_EExpesTS")=="true";
				document.getElementById("cGC_EPrepaExpes").checked = contenu.getAttribute("MenuGC_EPrepaExpes")=="true";
				document.getElementById("cGC_EExpCrossDock").checked = contenu.getAttribute("MenuGC_EExpCrossDock")=="true";
				document.getElementById("cGC_ESuiviLog").checked = contenu.getAttribute("MenuGC_ESuiviLog")=="true";
				document.getElementById("cGC_ESuiviTrans").checked = contenu.getAttribute("MenuGC_ESuiviTrans")=="true";

				// Accs menus comptabilit
				document.getElementById("cCG_CSaisie").checked = contenu.getAttribute("MenuCG_CSaisie")=="true";
				document.getElementById("cCG_EBalance").checked = contenu.getAttribute("MenuCG_EBalance")=="true";
				document.getElementById("cCG_SBordGest").checked = contenu.getAttribute("MenuCG_SBordGest")=="true";
				document.getElementById("cCG_AComptes").checked = contenu.getAttribute("MenuCG_AComptes")=="true";
				document.getElementById("cCG_DComptes").checked = contenu.getAttribute("MenuCG_DComptes")=="true";
				document.getElementById("cCG_CRevision").checked = contenu.getAttribute("MenuCG_CRevision")=="true";
				document.getElementById("cCG_ECentral").checked = contenu.getAttribute("MenuCG_ECentral")=="true";
				document.getElementById("cCG_SBordTres").checked = contenu.getAttribute("MenuCG_SBordTres")=="true";
				document.getElementById("cCG_AGdLivre").checked = contenu.getAttribute("MenuCG_AGdLivre")=="true";
				document.getElementById("cCG_DAboEcr").checked = contenu.getAttribute("MenuCG_DAboEcr")=="true";
				document.getElementById("cCG_CTransCop").checked = contenu.getAttribute("MenuCG_CTransCop")=="true";
				document.getElementById("cCG_EGdLivre").checked = contenu.getAttribute("MenuCG_EGdLivre")=="true";
				document.getElementById("cCG_AParametrages").checked = contenu.getAttribute("MenuCG_AParametrages")=="true";
				document.getElementById("cCG_DModeles").checked = contenu.getAttribute("MenuCG_DModeles")=="true";
				document.getElementById("cCG_CRappro").checked = contenu.getAttribute("MenuCG_CRappro")=="true";
				document.getElementById("cCG_EJournaux").checked = contenu.getAttribute("MenuCG_EJournaux")=="true";
				document.getElementById("cCG_DImpBanque").checked = contenu.getAttribute("MenuCG_DImpBanque")=="true";
				document.getElementById("cCG_CClotMens").checked = contenu.getAttribute("MenuCG_CClotMens")=="true";
				document.getElementById("cCG_EBalAgee").checked = contenu.getAttribute("MenuCG_EBalAgee")=="true";
				document.getElementById("cCG_DImpExpEcr").checked = contenu.getAttribute("MenuCG_DImpExpEcr")=="true";
				document.getElementById("cCG_CClotExo").checked = contenu.getAttribute("MenuCG_CClotExo")=="true";
				document.getElementById("cCG_EBilan").checked = contenu.getAttribute("MenuCG_EBilan")=="true";
				document.getElementById("cCG_DPassword").checked = contenu.getAttribute("MenuCG_DPassword")=="true";
				document.getElementById("cCG_EResultat").checked = contenu.getAttribute("MenuCG_EResultat")=="true";
				document.getElementById("cCG_ESoldes").checked = contenu.getAttribute("MenuCG_ESoldes")=="true";
				document.getElementById("cCG_EPlanCpte").checked = contenu.getAttribute("MenuCG_EPlanCpte")=="true";

				// Accs menus module flash
				document.getElementById("cMWM_ExpMonoBL").checked = contenu.getAttribute("MenuMWM_ExpMonoBL")=="true";
				document.getElementById("cMWM_ExpMultiBL").checked = contenu.getAttribute("MenuMWM_ExpMultiBL")=="true";
				document.getElementById("cMWM_CdeClient").checked = contenu.getAttribute("MenuMWM_CdeClient")=="true";
				document.getElementById("cMWM_PrepExpedition").checked = contenu.getAttribute("MenuMWM_PrepExpedition")=="true";
				document.getElementById("cMWM_InfoArticle").checked = contenu.getAttribute("MenuMWM_InfoArticle")=="true";
				document.getElementById("cMWM_Inventaire").checked = contenu.getAttribute("MenuMWM_Inventaire")=="true";
				document.getElementById("cMWM_Inv_Show_SI").checked = contenu.getAttribute("MWM_Inv_Show_SI")=="true";
				document.getElementById("cMWM_Reception").checked = contenu.getAttribute("MenuMWM_Reception")=="true";
				document.getElementById("cMWM_Rangement").checked = contenu.getAttribute("MenuMWM_Rangement")=="true";
				document.getElementById("cMWM_LocCrossDock").checked = contenu.getAttribute("MenuMWM_LocCrossDock")=="true";
				document.getElementById("cMWM_ExpCrossDock").checked = contenu.getAttribute("MenuMWM_ExpCrossDock")=="true";
				document.getElementById("cMWM_EntSortStk").checked = contenu.getAttribute("MenuMWM_EntSortStk")=="true";
				document.getElementById("cMWM_ChangeEmp").checked = contenu.getAttribute("MenuMWM_ChangeEmp")=="true";
				document.getElementById("cMWM_TransEmp").checked = contenu.getAttribute("MenuMWM_TransEmp")=="true";
				document.getElementById("cMWM_ConsultEmp").checked = contenu.getAttribute("MenuMWM_ConsultEmp")=="true";
				document.getElementById("cMWM_RecepRetCli").checked = contenu.getAttribute("MenuMWM_RecepRetCli")=="true";
				document.getElementById("cMWM_Picking").checked = contenu.getAttribute("MenuMWM_Picking")=="true";
				document.getElementById("cMWM_Controle_Picking").checked = contenu.getAttribute("MWM_Controle_Picking")=="true";
				document.getElementById("cMWM_PrepExpress").checked = contenu.getAttribute("MenuMWM_PrepExpress")=="true";
				document.getElementById("cMWM_Controle").checked = contenu.getAttribute("MenuMWM_Controle")=="true";
				document.getElementById("cMWM_Impression").checked = contenu.getAttribute("MenuMWM_Impression")=="true";
				document.getElementById("cMWM_Localisation").checked = contenu.getAttribute("MenuMWM_Localisation")=="true";
				document.getElementById("cMWM_PEX_Quantite").checked = contenu.getAttribute("MWM_PEX_Quantite")=="true";
				document.getElementById("cMWM_PEX_Qte_Manquante").checked = contenu.getAttribute("MWM_PEX_Qte_Manquante")=="true";
				document.getElementById("cMWM_Scan_Borne").checked = contenu.getAttribute("MWM_Scan_Borne")=="true";
				document.getElementById("cMWM_Info_Art_Chg_Emp").checked = contenu.getAttribute("MWM_Info_Art_Chg_Emp")=="true";

				document.getElementById("bSupprimer").disabled = false;

				document.getElementById("cMaxValidationDC").disabled = !document.getElementById("cValidationDC").checked;
				document.getElementById("cModifElemFinFCA").disabled = !document.getElementById("cModifElemFinDV").checked;
			}
		}

	} catch (e) {
    recup_erreur(e);
  }
}


function supprimerProfil() {
	try {

		if (!isEmpty(currentProfilId) && window.confirm("Confirmez-vous la suppression de ce profil ?")) {

			var qDelete = new QueryHttp("Utilisateurs/Profils/deleteProfilType.tmpl");
			qDelete.setParam("Profil_Id", currentProfilId);
			qDelete.execute();

			nouveauProfil();
		}

	} catch (e) {
    recup_erreur(e);
  }
}


function enregistrerProfil() {
	try {

		var intitule = document.getElementById('Intitule').value;
		var commentaires = document.getElementById('Commentaires').value;

		// droits gnraux
		var acc_compta = document.getElementById("cCompta").checked;
		var acc_contact = document.getElementById("cContact").checked;
		var acc_transac = document.getElementById("cTransac").checked;
		var acc_gest_com = document.getElementById("cGestionCo").checked;
		var acc_config = document.getElementById("cConfig").checked;
		var acc_flash = document.getElementById("cFlash").checked;
		var direction = document.getElementById("cDirection").checked;
		var validationCF = document.getElementById("cValidationCF").checked;
		var validationCC = document.getElementById("cValidationCC").checked;
		var validationCCZero = document.getElementById("cValidationCCZero").checked;
		var annulationCC = document.getElementById("cAnnulationCC").checked;
		var validationTS = document.getElementById("cValidationTS").checked;
		var validationIS = document.getElementById("cValidationIS").checked;
		var validationRG = document.getElementById("cValidationRG").checked;
		var validationBR = document.getElementById("cValidationBR").checked;
		var validationAF = document.getElementById("cValidationAF").checked;
		var validationAC = document.getElementById("cValidationAC").checked;
		var validationBP = document.getElementById("cValidationBP").checked;
		var annulationBP = document.getElementById("cAnnulationBP").checked;
		var validationBL = document.getElementById("cValidationBL").checked;
		var annulationBL = document.getElementById("cAnnulationBL").checked;
		var validationDC = document.getElementById("cValidationDC").checked;
		var maxValidationDC = validationDC?document.getElementById("cMaxValidationDC").value:"";
		var clotureFact = document.getElementById("cClotureFact").checked;
		var modifElemFinDV = document.getElementById("cModifElemFinDV").checked;
		var modifElemFinFCA = document.getElementById("cModifElemFinFCA").checked;
		var ignorePVPlancher = document.getElementById("cIgnorePVPlancher").checked;
		var editionListeDL = document.getElementById("cEditionListeDL").checked;
		var editionListeDA = document.getElementById("cEditionListeDA").checked;
		var editionListeDV = document.getElementById("cEditionListeDV").checked;
		var showTotauxDV = document.getElementById("cShowTotauxDV").checked;
		var accesCoutAchat = document.getElementById("cAccesCoutAchat").checked;
		var accesCoordBanque = document.getElementById("cAccesCoordBanque").checked;
		var restricAccCDVPA = document.getElementById("cRestricAccCDVPA").checked;
		var gestionDevisType = document.getElementById("cGestionDevisType").checked;
		var gestionRespVente = document.getElementById("cGestionRespVente").checked;
		var gestionPoleVente = document.getElementById("cGestionPoleVente").checked;
		var gestionIntiVente = document.getElementById("cGestionIntiVente").checked;
		var gestionBloqueCli = document.getElementById("cGestionBloqueCli").checked;
		var modifStockES = document.getElementById("cModifStockES").checked;
		var modifPrixFA = document.getElementById("cModifPrixFA").checked;
		var anonymisationFC = document.getElementById("cAnonymisationFC").checked;

		// accs aux menus de gestion commerciale
		var MenuGC_TClients = document.getElementById("cGC_TClients").checked;
		var ReadOnlyGC_TClients = document.getElementById("cReadOnlyGC_TClients").checked;
		var MenuGC_TFournisseurs = document.getElementById("cGC_TFournisseurs").checked;
		var MenuGC_TCommerciaux = document.getElementById("cGC_TCommerciaux").checked;

		var MenuGC_VDevis = document.getElementById("cGC_VDevis").checked;
		var MenuGC_VAffaires = document.getElementById("cGC_VAffaires").checked;
		var ReadOnlyGC_VDevis = document.getElementById("cReadOnlyGC_VDevis").checked;
		var ReadOnlyGC_VAffaires = document.getElementById("cReadOnlyGC_VAffaires").checked;
		var MenuGC_VRetours = document.getElementById("cGC_VRetours").checked;
		var MenuGC_VFactures = document.getElementById("cGC_VFactures").checked;
		var MenuGC_VFactuAuto = document.getElementById("cGC_VFactuAuto").checked;
		var MenuGC_VEnvoiFact = document.getElementById("cGC_VEnvoiFact").checked;
		var MenuGC_VAbonnements = document.getElementById("cGC_VAbonnements").checked;

		var MenuGC_EExpesCC = document.getElementById("cGC_EExpesCC").checked;
		var MenuGC_EExpesTS = document.getElementById("cGC_EExpesTS").checked;
		var MenuGC_EPrepaExpes = document.getElementById("cGC_EPrepaExpes").checked;
		var MenuGC_EExpCrossDock = document.getElementById("cGC_EExpCrossDock").checked;
		var MenuGC_ESuiviLog = document.getElementById("cGC_ESuiviLog").checked;
		var MenuGC_ESuiviTrans = document.getElementById("cGC_ESuiviTrans").checked;

		var MenuGC_ACommandes = document.getElementById("cGC_ACommandes").checked;
		var MenuGC_APrepaCom = document.getElementById("cGC_APrepaCom").checked;
		var MenuGC_ARecepCom = document.getElementById("cGC_ARecepCom").checked;
		var MenuGC_ARetours = document.getElementById("cGC_ARetours").checked;
		var MenuGC_AFactures = document.getElementById("cGC_AFactures").checked;
		var MenuGC_AControle = document.getElementById("cGC_AControle").checked;

		var MenuGC_SArticles = document.getElementById("cGC_SArticles").checked;
		var ReadOnlyGC_SArticles = document.getElementById("cReadOnlyGC_SArticles").checked;
		var MenuGC_STarifs = document.getElementById("cGC_STarifs").checked;
		var MenuGC_SFabrication = document.getElementById("cGC_SFabrication").checked;
		var MenuGC_SInventaire = document.getElementById("cGC_SInventaire").checked;
		var MenuGC_STracabilite = document.getElementById("cGC_STracabilite").checked;
		var MenuGC_STransferts = document.getElementById("cGC_STransferts").checked;
		var MenuGC_SMouvements = document.getElementById("cGC_SMouvements").checked;
		var MenuGC_SEmplacements = document.getElementById("cGC_SEmplacements").checked;
		var MenuGC_STransEmp = document.getElementById("cGC_STransEmp").checked;
		var MenuGC_SIOStocks = document.getElementById("cGC_SIOStocks").checked;
		var ReadOnlyGC_SIOStocks = document.getElementById("cReadOnlyGC_SIOStocks").checked;
		var MenuGC_SParamStocks = document.getElementById("cGC_SParamStocks").checked;

		var MenuGC_DRegFour =  document.getElementById("cGC_DRegFour").checked;
		var MenuGC_DRegCli = document.getElementById("cGC_DRegCli").checked;
		var ReadOnlyGC_DRegCli = document.getElementById("cReadOnlyGC_DRegCli").checked;
		var MenuGC_DRemises = document.getElementById("cGC_DRemises").checked;
		var MenuGC_DEditions = document.getElementById("cGC_DEditions").checked;
		var MenuGC_DTabBord = document.getElementById("cGC_DTabBord").checked;
		var MenuGC_DTransCpta = document.getElementById("cGC_DTransCpta").checked;
		var MenuGC_DExportIdep = document.getElementById("cGC_DExportIdep").checked;
		var MenuGC_DDeclEcoPart = document.getElementById("cGC_DDeclEcoPart").checked;
		var MenuGC_DImpExpCsv = document.getElementById("cGC_DImpExpCsv").checked;
		var MenuGC_DPassword = document.getElementById("cGC_DPassword").checked;

		// accs menus comptabilit
		var MenuCG_CSaisie = document.getElementById("cCG_CSaisie").checked;
		var MenuCG_CRevision = document.getElementById("cCG_CRevision").checked;
		var MenuCG_CTransCop = document.getElementById("cCG_CTransCop").checked;
		var MenuCG_CRappro = document.getElementById("cCG_CRappro").checked;
		var MenuCG_CClotMens = document.getElementById("cCG_CClotMens").checked;
		var MenuCG_CClotExo = document.getElementById("cCG_CClotExo").checked;

		var MenuCG_EBalance = document.getElementById("cCG_EBalance").checked;
		var MenuCG_ECentral = document.getElementById("cCG_ECentral").checked;
		var MenuCG_EGdLivre = document.getElementById("cCG_EGdLivre").checked;
		var MenuCG_EJournaux = document.getElementById("cCG_EJournaux").checked;
		var MenuCG_EBalAgee = document.getElementById("cCG_EBalAgee").checked;
		var MenuCG_EBilan = document.getElementById("cCG_EBilan").checked;
		var MenuCG_EResultat = document.getElementById("cCG_EResultat").checked;
		var MenuCG_ESoldes = document.getElementById("cCG_ESoldes").checked;
		var MenuCG_EPlanCpte = document.getElementById("cCG_EPlanCpte").checked;

		var MenuCG_SBordGest = document.getElementById("cCG_SBordGest").checked;
		var MenuCG_SBordTres = document.getElementById("cCG_SBordTres").checked;

		var MenuCG_AComptes = document.getElementById("cCG_AComptes").checked;
		var MenuCG_AGdLivre = document.getElementById("cCG_AGdLivre").checked;
		var MenuCG_AParametrages = document.getElementById("cCG_AParametrages").checked;

		var MenuCG_DComptes = document.getElementById("cCG_DComptes").checked;
		var MenuCG_DAboEcr = document.getElementById("cCG_DAboEcr").checked;
		var MenuCG_DModeles = document.getElementById("cCG_DModeles").checked;
		var MenuCG_DImpBanque = document.getElementById("cCG_DImpBanque").checked;
		var MenuCG_DImpExpEcr = document.getElementById("cCG_DImpExpEcr").checked;
		var MenuCG_DPassword = document.getElementById("cCG_DPassword").checked;

		// accs menus module flash
		var MenuMWM_ExpMonoBL = document.getElementById("cMWM_ExpMonoBL").checked;
		var MenuMWM_ExpMultiBL = document.getElementById("cMWM_ExpMultiBL").checked;
		var MenuMWM_CdeClient = document.getElementById("cMWM_CdeClient").checked;
		var MenuMWM_PrepExpedition = document.getElementById("cMWM_PrepExpedition").checked;
		var MenuMWM_InfoArticle = document.getElementById("cMWM_InfoArticle").checked;
		var MenuMWM_Inventaire = document.getElementById("cMWM_Inventaire").checked;
		var MWM_Inv_Show_SI = document.getElementById("cMWM_Inv_Show_SI").checked;
		var MenuMWM_Reception = document.getElementById("cMWM_Reception").checked;
		var MenuMWM_Rangement = document.getElementById("cMWM_Rangement").checked;
		var MenuMWM_LocCrossDock = document.getElementById("cMWM_LocCrossDock").checked;
		var MenuMWM_ExpCrossDock = document.getElementById("cMWM_ExpCrossDock").checked;
		var MenuMWM_EntSortStk = document.getElementById("cMWM_EntSortStk").checked;
		var MenuMWM_ChangeEmp = document.getElementById("cMWM_ChangeEmp").checked;
		var MenuMWM_TransEmp = document.getElementById("cMWM_TransEmp").checked;
		var MenuMWM_ConsultEmp = document.getElementById("cMWM_ConsultEmp").checked;
		var MenuMWM_RecepRetCli = document.getElementById("cMWM_RecepRetCli").checked;
		var MenuMWM_Picking = document.getElementById("cMWM_Picking").checked;
		var MWM_Controle_Picking = document.getElementById("cMWM_Controle_Picking").checked;
		var MenuMWM_PrepExpress = document.getElementById("cMWM_PrepExpress").checked;
		var MenuMWM_Controle = document.getElementById("cMWM_Controle").checked;
		var MenuMWM_Impression = document.getElementById("cMWM_Impression").checked;
		var MenuMWM_Localisation = document.getElementById("cMWM_Localisation").checked;
		var MWM_PEX_Quantite = document.getElementById("cMWM_PEX_Quantite").checked;
		var MWM_PEX_Qte_Manquante = document.getElementById("cMWM_PEX_Qte_Manquante").checked;
		var MWM_Scan_Borne = document.getElementById("cMWM_Scan_Borne").checked;
		var MWM_Info_Art_Chg_Emp = document.getElementById("cMWM_Info_Art_Chg_Emp").checked;

		if (intitule=="") {
			showWarning("Veuillez saisir un intitul\u00E9");
		}
		else if (!isEmpty(maxValidationDC) && !isPositiveOrNull(maxValidationDC)) {
			showWarning("Montant maximum de validation d'un devis incorrect");
		}
		else {

			var qSaveProfil;

			if(currentProfilId != "") {
				qSaveProfil = new QueryHttp("Utilisateurs/Profils/updateProfilType.tmpl");
				qSaveProfil.setParam("Profil_Id", currentProfilId);
			}
			else {
				qSaveProfil = new QueryHttp("Utilisateurs/Profils/createProfilType.tmpl");
			}

			qSaveProfil.setParam("Intitule", intitule);
			qSaveProfil.setParam("Commentaires", commentaires);

			// droits gnraux
			qSaveProfil.setParam("Acc_Compta", acc_compta);
			qSaveProfil.setParam("Acc_CRM", acc_contact);
			qSaveProfil.setParam("Acc_Gest_Com", acc_gest_com);
			qSaveProfil.setParam("Acc_TB", acc_transac);
			qSaveProfil.setParam("Acc_Config", acc_config);
			qSaveProfil.setParam("Acc_MWM", acc_flash);
			qSaveProfil.setParam("Direction", direction);
			qSaveProfil.setParam("Validation_CF", validationCF);
			qSaveProfil.setParam("Validation_CC", validationCC);
			qSaveProfil.setParam("Validation_CC_Zero", validationCCZero);
			qSaveProfil.setParam("Annulation_CC", annulationCC);
			qSaveProfil.setParam("Validation_TS", validationTS);
			qSaveProfil.setParam("Validation_IS", validationIS);
			qSaveProfil.setParam("Validation_RG", validationRG);
			qSaveProfil.setParam("Validation_BR", validationBR);
			qSaveProfil.setParam("Validation_AF", validationAF);
			qSaveProfil.setParam("Validation_AC", validationAC);
			qSaveProfil.setParam("Validation_BP", validationBP);
			qSaveProfil.setParam("Annulation_BP", annulationBP);
			qSaveProfil.setParam("Validation_BL", validationBL);
			qSaveProfil.setParam("Annulation_BL", annulationBL);
			qSaveProfil.setParam("Validation_DC", validationDC);
			qSaveProfil.setParam("Max_Validation_DC", maxValidationDC);
			qSaveProfil.setParam("Cloture_Fact", clotureFact);
			qSaveProfil.setParam("Modif_Elem_Fin_DV", modifElemFinDV);
			qSaveProfil.setParam("Modif_Elem_Fin_FCA", modifElemFinFCA);
			qSaveProfil.setParam("Ignore_PV_Plancher", ignorePVPlancher);
			qSaveProfil.setParam("Edition_Liste_DL", editionListeDL);
			qSaveProfil.setParam("Edition_Liste_DA", editionListeDA);
			qSaveProfil.setParam("Edition_Liste_DV", editionListeDV);
			qSaveProfil.setParam("Show_Totaux_DV", showTotauxDV);
			qSaveProfil.setParam("Acces_Cout_Achat", accesCoutAchat);
			qSaveProfil.setParam("Acces_Coord_Banque", accesCoordBanque);
			qSaveProfil.setParam("Restric_Acc_CDV_PA", restricAccCDVPA);
			qSaveProfil.setParam("Gestion_Devis_Type", gestionDevisType);
			qSaveProfil.setParam("Gestion_Resp_Vente", gestionRespVente);
			qSaveProfil.setParam("Gestion_Pole_Vente", gestionPoleVente);
			qSaveProfil.setParam("Gestion_Inti_Vente", gestionIntiVente);
			qSaveProfil.setParam("Gestion_Bloque_Cli", gestionBloqueCli);
			qSaveProfil.setParam("Modif_Stock_ES", modifStockES);
			qSaveProfil.setParam("Modif_Prix_FA", modifPrixFA);
			qSaveProfil.setParam("Anonymisation_FC", anonymisationFC);

			// acces aux menus de gestion commerciale
			qSaveProfil.setParam("MenuGC_TClients", MenuGC_TClients);
			qSaveProfil.setParam("ReadOnlyGC_TClients", ReadOnlyGC_TClients);
			qSaveProfil.setParam("MenuGC_TFournisseurs", MenuGC_TFournisseurs);
			qSaveProfil.setParam("MenuGC_TCommerciaux", MenuGC_TCommerciaux);

			qSaveProfil.setParam("MenuGC_VDevis", MenuGC_VDevis);
			qSaveProfil.setParam("MenuGC_VAffaires", MenuGC_VAffaires);
			qSaveProfil.setParam("ReadOnlyGC_VDevis", ReadOnlyGC_VDevis);
			qSaveProfil.setParam("ReadOnlyGC_VAffaires", ReadOnlyGC_VAffaires);
			qSaveProfil.setParam("MenuGC_VRetours", MenuGC_VRetours);
			qSaveProfil.setParam("MenuGC_VFactures", MenuGC_VFactures);
			qSaveProfil.setParam("MenuGC_VFactuAuto", MenuGC_VFactuAuto);
			qSaveProfil.setParam("MenuGC_VEnvoiFact", MenuGC_VEnvoiFact);
			qSaveProfil.setParam("MenuGC_VAbonnements", MenuGC_VAbonnements);

			qSaveProfil.setParam("MenuGC_EExpesCC", MenuGC_EExpesCC);
			qSaveProfil.setParam("MenuGC_EExpesTS", MenuGC_EExpesTS);
			qSaveProfil.setParam("MenuGC_EPrepaExpes", MenuGC_EPrepaExpes);
			qSaveProfil.setParam("MenuGC_EExpCrossDock", MenuGC_EExpCrossDock);
			qSaveProfil.setParam("MenuGC_ESuiviLog", MenuGC_ESuiviLog);
			qSaveProfil.setParam("MenuGC_ESuiviTrans", MenuGC_ESuiviTrans);

			qSaveProfil.setParam("MenuGC_ACommandes", MenuGC_ACommandes);
			qSaveProfil.setParam("MenuGC_APrepaCom", MenuGC_APrepaCom);
			qSaveProfil.setParam("MenuGC_ARecepCom", MenuGC_ARecepCom);
			qSaveProfil.setParam("MenuGC_ARetours", MenuGC_ARetours);
			qSaveProfil.setParam("MenuGC_AFactures", MenuGC_AFactures);
			qSaveProfil.setParam("MenuGC_AControle", MenuGC_AControle);

			qSaveProfil.setParam("MenuGC_SArticles", MenuGC_SArticles);
			qSaveProfil.setParam("ReadOnlyGC_SArticles", ReadOnlyGC_SArticles);
			qSaveProfil.setParam("MenuGC_STarifs", MenuGC_STarifs);
			qSaveProfil.setParam("MenuGC_SFabrication", MenuGC_SFabrication);
			qSaveProfil.setParam("MenuGC_SInventaire", MenuGC_SInventaire);
			qSaveProfil.setParam("MenuGC_STracabilite", MenuGC_STracabilite);
			qSaveProfil.setParam("MenuGC_STransferts", MenuGC_STransferts);
			qSaveProfil.setParam("MenuGC_SMouvements", MenuGC_SMouvements);
			qSaveProfil.setParam("MenuGC_SEmplacements", MenuGC_SEmplacements);
			qSaveProfil.setParam("MenuGC_STransEmp", MenuGC_STransEmp);
			qSaveProfil.setParam("MenuGC_SIOStocks", MenuGC_SIOStocks);
			qSaveProfil.setParam("ReadOnlyGC_SIOStocks", ReadOnlyGC_SIOStocks);
			qSaveProfil.setParam("MenuGC_SParamStocks", MenuGC_SParamStocks);

			qSaveProfil.setParam("MenuGC_DRegFour", MenuGC_DRegFour);
			qSaveProfil.setParam("MenuGC_DRegCli", MenuGC_DRegCli);
			qSaveProfil.setParam("ReadOnlyGC_DRegCli", ReadOnlyGC_DRegCli);
			qSaveProfil.setParam("MenuGC_DRemises", MenuGC_DRemises);
			qSaveProfil.setParam("MenuGC_DEditions", MenuGC_DEditions);
			qSaveProfil.setParam("MenuGC_DTabBord", MenuGC_DTabBord);
			qSaveProfil.setParam("MenuGC_DTransCpta", MenuGC_DTransCpta);
			qSaveProfil.setParam("MenuGC_DExportIdep", MenuGC_DExportIdep);
			qSaveProfil.setParam("MenuGC_DDeclEcoPart", MenuGC_DDeclEcoPart);
			qSaveProfil.setParam("MenuGC_DImpExpCsv", MenuGC_DImpExpCsv);
			qSaveProfil.setParam("MenuGC_DPassword", MenuGC_DPassword);

			// accs menus comptabilit
			qSaveProfil.setParam("MenuCG_CSaisie", MenuCG_CSaisie);
			qSaveProfil.setParam("MenuCG_CRevision", MenuCG_CRevision);
			qSaveProfil.setParam("MenuCG_CTransCop", MenuCG_CTransCop);
			qSaveProfil.setParam("MenuCG_CRappro", MenuCG_CRappro);
			qSaveProfil.setParam("MenuCG_CClotMens", MenuCG_CClotMens);
			qSaveProfil.setParam("MenuCG_CClotExo", MenuCG_CClotExo);

			qSaveProfil.setParam("MenuCG_EBalance", MenuCG_EBalance);
			qSaveProfil.setParam("MenuCG_ECentral", MenuCG_ECentral);
			qSaveProfil.setParam("MenuCG_EGdLivre", MenuCG_EGdLivre);
			qSaveProfil.setParam("MenuCG_EJournaux", MenuCG_EJournaux);
			qSaveProfil.setParam("MenuCG_EBalAgee", MenuCG_EBalAgee);
			qSaveProfil.setParam("MenuCG_EBilan", MenuCG_EBilan);
			qSaveProfil.setParam("MenuCG_EResultat", MenuCG_EResultat);
			qSaveProfil.setParam("MenuCG_ESoldes", MenuCG_ESoldes);
			qSaveProfil.setParam("MenuCG_EPlanCpte", MenuCG_EPlanCpte);

			qSaveProfil.setParam("MenuCG_SBordGest", MenuCG_SBordGest);
			qSaveProfil.setParam("MenuCG_SBordTres", MenuCG_SBordTres);

			qSaveProfil.setParam("MenuCG_AComptes", MenuCG_AComptes);
			qSaveProfil.setParam("MenuCG_AGdLivre", MenuCG_AGdLivre);
			qSaveProfil.setParam("MenuCG_AParametrages", MenuCG_AParametrages);

			qSaveProfil.setParam("MenuCG_DComptes", MenuCG_DComptes);
			qSaveProfil.setParam("MenuCG_DAboEcr", MenuCG_DAboEcr);
			qSaveProfil.setParam("MenuCG_DModeles", MenuCG_DModeles);
			qSaveProfil.setParam("MenuCG_DImpBanque", MenuCG_DImpBanque);
			qSaveProfil.setParam("MenuCG_DImpExpEcr", MenuCG_DImpExpEcr);
			qSaveProfil.setParam("MenuCG_DPassword", MenuCG_DPassword);

			// accs menus module flash
			qSaveProfil.setParam("MenuMWM_ExpMonoBL", MenuMWM_ExpMonoBL);
			qSaveProfil.setParam("MenuMWM_ExpMultiBL", MenuMWM_ExpMultiBL);
			qSaveProfil.setParam("MenuMWM_CdeClient", MenuMWM_CdeClient);
			qSaveProfil.setParam("MenuMWM_PrepExpedition", MenuMWM_PrepExpedition);
			qSaveProfil.setParam("MenuMWM_InfoArticle", MenuMWM_InfoArticle);
			qSaveProfil.setParam("MenuMWM_Inventaire", MenuMWM_Inventaire);
			qSaveProfil.setParam("MWM_Inv_Show_SI", MWM_Inv_Show_SI);
			qSaveProfil.setParam("MenuMWM_Reception", MenuMWM_Reception);
			qSaveProfil.setParam("MenuMWM_Rangement", MenuMWM_Rangement);
			qSaveProfil.setParam("MenuMWM_LocCrossDock", MenuMWM_LocCrossDock);
			qSaveProfil.setParam("MenuMWM_ExpCrossDock", MenuMWM_ExpCrossDock);
			qSaveProfil.setParam("MenuMWM_EntSortStk", MenuMWM_EntSortStk);
			qSaveProfil.setParam("MenuMWM_ChangeEmp", MenuMWM_ChangeEmp);
			qSaveProfil.setParam("MenuMWM_TransEmp", MenuMWM_TransEmp);
			qSaveProfil.setParam("MenuMWM_ConsultEmp", MenuMWM_ConsultEmp);
			qSaveProfil.setParam("MenuMWM_RecepRetCli", MenuMWM_RecepRetCli);
			qSaveProfil.setParam("MenuMWM_Picking", MenuMWM_Picking);
			qSaveProfil.setParam("MWM_Controle_Picking", MWM_Controle_Picking);
			qSaveProfil.setParam("MenuMWM_PrepExpress", MenuMWM_PrepExpress);
			qSaveProfil.setParam("MenuMWM_Controle", MenuMWM_Controle);
			qSaveProfil.setParam("MenuMWM_Impression", MenuMWM_Impression);
			qSaveProfil.setParam("MenuMWM_Localisation", MenuMWM_Localisation);
			qSaveProfil.setParam("MWM_PEX_Quantite", MWM_PEX_Quantite);
			qSaveProfil.setParam("MWM_PEX_Qte_Manquante", MWM_PEX_Qte_Manquante);
			qSaveProfil.setParam("MWM_Scan_Borne", MWM_Scan_Borne);
			qSaveProfil.setParam("MWM_Info_Art_Chg_Emp", MWM_Info_Art_Chg_Emp);

			var result = qSaveProfil.execute();
			var errors = new Errors(result);

			if (errors.hasNext()) {
				errors.show();
			}
			else {
				if (currentProfilId == "") {
					currentProfilId = result.responseXML.documentElement.getAttribute("Profil_Id");
				}

				aProfils.initTree();

				document.getElementById("bSupprimer").disabled = false;
			}
		}

	} catch (e) {
    recup_erreur(e);
  }
}


function cocherCompta(b) {
	try {

		document.getElementById("cCG_CSaisie").checked = b;
		document.getElementById("cCG_EBalance").checked = b;
		document.getElementById("cCG_SBordGest").checked = b;
		document.getElementById("cCG_AComptes").checked = b;
		document.getElementById("cCG_DComptes").checked = b;
		document.getElementById("cCG_CRevision").checked = b;
		document.getElementById("cCG_ECentral").checked = b;
		document.getElementById("cCG_SBordTres").checked = b;
		document.getElementById("cCG_AGdLivre").checked = b;
		document.getElementById("cCG_DAboEcr").checked = b;
		document.getElementById("cCG_CTransCop").checked = b;
		document.getElementById("cCG_EGdLivre").checked = b;
		document.getElementById("cCG_AParametrages").checked = b;
		document.getElementById("cCG_DModeles").checked = b;
		document.getElementById("cCG_CRappro").checked = b;
		document.getElementById("cCG_EJournaux").checked = b;
		document.getElementById("cCG_DImpBanque").checked = b;
		document.getElementById("cCG_CClotMens").checked = b;
		document.getElementById("cCG_EBalAgee").checked = b;
		document.getElementById("cCG_DImpExpEcr").checked = b;
		document.getElementById("cCG_CClotExo").checked = b;
		document.getElementById("cCG_EBilan").checked = b;
		document.getElementById("cCG_DPassword").checked = b;
		document.getElementById("cCG_EResultat").checked = b;
		document.getElementById("cCG_ESoldes").checked = b;
		document.getElementById("cCG_EPlanCpte").checked = b;

  } catch (e) {
    recup_erreur(e);
  }
}


function cocherGC(b) {
	try {

		document.getElementById("cGC_TClients").checked = b;
		document.getElementById("cGC_VDevis").checked = b;
		document.getElementById("cGC_ACommandes").checked = b;
		document.getElementById("cGC_SArticles").checked = b;
		document.getElementById("cGC_DRegFour").checked = b;
		document.getElementById("cGC_TFournisseurs").checked = b;
		document.getElementById("cGC_VAffaires").checked = b;
		document.getElementById("cGC_APrepaCom").checked = b;
		document.getElementById("cGC_STarifs").checked = b;
		document.getElementById("cGC_DRegCli").checked = b;
		document.getElementById("cGC_TCommerciaux").checked = b;
		document.getElementById("cGC_ARecepCom").checked = b;
		document.getElementById("cGC_SFabrication").checked = b;
		document.getElementById("cGC_DRemises").checked = b;
		document.getElementById("cGC_ARetours").checked = b;
		document.getElementById("cGC_SInventaire").checked = b;
		document.getElementById("cGC_DEditions").checked = b;
		document.getElementById("cGC_AFactures").checked = b;
		document.getElementById("cGC_AControle").checked = b || !ofu_specLHCFF;
		document.getElementById("cGC_STracabilite").checked = b;
		document.getElementById("cGC_DTabBord").checked = b;
		document.getElementById("cGC_VFactures").checked = b;
		document.getElementById("cGC_VRetours").checked = b;
		document.getElementById("cGC_STransferts").checked = b;
		document.getElementById("cGC_DTransCpta").checked = b;
		document.getElementById("cGC_VFactuAuto").checked = b;
		document.getElementById("cGC_SMouvements").checked = b;
		document.getElementById("cGC_SEmplacements").checked = b;
		document.getElementById("cGC_STransEmp").checked = b;
		document.getElementById("cGC_SIOStocks").checked = b;
		document.getElementById("cGC_SParamStocks").checked = b;
		document.getElementById("cGC_DExportIdep").checked = b;
		document.getElementById("cGC_DDeclEcoPart").checked = b;
		document.getElementById("cGC_VEnvoiFact").checked = b;
		document.getElementById("cGC_DImpExpCsv").checked = b;
		document.getElementById("cGC_VAbonnements").checked = b;
		document.getElementById("cGC_DPassword").checked = b;
		document.getElementById("cGC_EExpesCC").checked = b;
		document.getElementById("cGC_EExpesTS").checked = b;
		document.getElementById("cGC_EPrepaExpes").checked = b;
		document.getElementById("cGC_EExpCrossDock").checked = b || !ofu_accCrossDock;
		document.getElementById("cGC_ESuiviLog").checked = b;
		document.getElementById("cGC_ESuiviTrans").checked = b;

  } catch (e) {
    recup_erreur(e);
  }
}


function cocherDG(b) {
	try {

		document.getElementById("cGestionCo").checked = b;
		document.getElementById("cCompta").checked = b;
		document.getElementById("cContact").checked = b;
		document.getElementById("cTransac").checked = b;
		document.getElementById("cConfig").checked = b;
		document.getElementById("cFlash").checked = b;
		document.getElementById("cDirection").checked = b;
		document.getElementById("cValidationCF").checked = b;
		document.getElementById("cValidationCC").checked = b;
		document.getElementById("cValidationCCZero").checked = b;
		document.getElementById("cAnnulationCC").checked = b;
		document.getElementById("cValidationTS").checked = b;
		document.getElementById("cValidationIS").checked = b;
		document.getElementById("cValidationRG").checked = b;
		document.getElementById("cValidationBR").checked = b;
		document.getElementById("cValidationAF").checked = b;
		document.getElementById("cValidationAC").checked = b;
		document.getElementById("cValidationBP").checked = b;
		document.getElementById("cAnnulationBP").checked = b;
		document.getElementById("cValidationBL").checked = b;
		document.getElementById("cAnnulationBL").checked = b;
		document.getElementById("cValidationDC").checked = b;
		document.getElementById("cMaxValidationDC").disabled = !b;
		document.getElementById("cClotureFact").checked = b;
		document.getElementById("cModifElemFinDV").checked = b;
		document.getElementById("cModifElemFinFCA").checked = b;
		document.getElementById("cIgnorePVPlancher").checked = b;
		document.getElementById("cEditionListeDL").checked = b;
		document.getElementById("cEditionListeDA").checked = b;
		document.getElementById("cEditionListeDV").checked = b;
		document.getElementById("cShowTotauxDV").checked = b;
		document.getElementById("cAccesCoutAchat").checked = b;
		document.getElementById("cAccesCoordBanque").checked = b;
		document.getElementById("cRestricAccCDVPA").checked = b && ofu_specLCARAP;
		document.getElementById("cGestionDevisType").checked = b;
		document.getElementById("cGestionRespVente").checked = b || !ofu_specLHGRV;
		document.getElementById("cGestionPoleVente").checked = b || !ofu_specLHGPV;
		document.getElementById("cGestionIntiVente").checked = b || !ofu_specLHGDV;
		document.getElementById("cGestionBloqueCli").checked = b || !ofu_specLVPBFC;
		document.getElementById("cModifStockES").checked = b;
		document.getElementById("cModifPrixFA").checked = b || !ofu_specTNMPA;
		document.getElementById("cAnonymisationFC").checked = b;

  } catch (e) {
    recup_erreur(e);
  }
}


function cocherMWM(b) {
	try {

		document.getElementById("cMWM_ExpMonoBL").checked = b && ofu_accMWMExpMonoBL;
		document.getElementById("cMWM_ExpMultiBL").checked = b && ofu_accMWMExpMultiBL;
		document.getElementById("cMWM_CdeClient").checked = b && ofu_accMWMCdeClient;
		document.getElementById("cMWM_PrepExpedition").checked = b;
		document.getElementById("cMWM_InfoArticle").checked = b;
		document.getElementById("cMWM_Inventaire").checked = b;
		document.getElementById("cMWM_Inv_Show_SI").checked = b;
		document.getElementById("cMWM_Reception").checked = b;
		document.getElementById("cMWM_Rangement").checked = b;
		document.getElementById("cMWM_LocCrossDock").checked = b && ofu_accCrossDock;
		document.getElementById("cMWM_ExpCrossDock").checked = b && ofu_accCrossDock;
		document.getElementById("cMWM_EntSortStk").checked = b;
		document.getElementById("cMWM_ChangeEmp").checked = b;
		document.getElementById("cMWM_TransEmp").checked = b;
		document.getElementById("cMWM_ConsultEmp").checked = b;
		document.getElementById("cMWM_RecepRetCli").checked = b;
		document.getElementById("cMWM_Picking").checked = b;
		document.getElementById("cMWM_Controle_Picking").checked = b;
		document.getElementById("cMWM_PrepExpress").checked = b;
		document.getElementById("cMWM_Controle").checked = b;
		document.getElementById("cMWM_Impression").checked = b;
		document.getElementById("cMWM_Localisation").checked = b;
		document.getElementById("cMWM_PEX_Quantite").checked = b;
		document.getElementById("cMWM_PEX_Qte_Manquante").checked = b;
		document.getElementById("cMWM_Scan_Borne").checked = b;
		document.getElementById("cMWM_Info_Art_Chg_Emp").checked = b;

  } catch (e) {
    recup_erreur(e);
  }
}


function clickOnValidationDC() {
	try {

		if (document.getElementById("cValidationDC").checked) {
			document.getElementById("cMaxValidationDC").disabled = false;
		}
		else {
			document.getElementById("cMaxValidationDC").disabled = true;
			document.getElementById("cMaxValidationDC").value = "";
		}

	} catch (e) {
    recup_erreur(e);
  }
}


function clickOnModifElemFinDV() {
	try {

		document.getElementById("cModifElemFinFCA").disabled = !document.getElementById("cModifElemFinDV").checked;

	} catch (e) {
    recup_erreur(e);
  }
}


function retour_menuGestionDroit() {
	try {

  	window.location = "chrome://opensi/content/utilisateurs/menu_utilisateurs.xul";

	} catch (e) {
    recup_erreur(e);
  }
}
